////////////////////////////////////////////////////////////////////////////////
// File name: CommonLib.cpp
// Author: Sergey Krivulya (Ce p) - KSerg (SeregaLBN)
// e-mail: Sergey_Krivulya@UkrPost.Net
// ICQ: 72099167
// WWW page: http://kserg77.narod.ru/CommonLib.html
// Date: 2007 06 14
//
// Description:   
////////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h" //     MFC /  Precompiled Headers

//#include <time.h>
#include <Math.h>
#include "CommonLib.h"
//#include "Icon.h" //  
#include <AtlConv.h>

#include <WinSock.h>
#pragma comment(lib, "ws2_32")

//#include <CommDlg.h>
//#pragma comment(lib, "ComDlg32")

#include <CDErr.h> // Common dialog error return codes

#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
   //#include <ObjBase.h> // CoInitializeEx
   //#pragma comment(lib, "ole32")
#endif // DCOM

//#include <WinVer.h>
#pragma comment(lib, "Version")

namespace nsWinInet_API {
   #include <WinInet.h>
}
#pragma comment(lib, "WinInet")

#include <IpHlpApi.h>
#pragma comment(lib, "IpHlpApi")

#ifdef __AFX_H__
   #ifdef _DEBUG
      #undef THIS_FILE
      static char THIS_FILE[]=__FILE__;
      #define new DEBUG_NEW
   #endif
#endif


// raster operation code
#define DSx  0x00660046L
#define DSna 0x00220326L

      
BOOL Base64_Code(
   IN BYTE const *pData,  //    - ,   
   IN DWORD dwSize,
   OUT LPTSTR szCodeData, //   -  
   IN OUT DWORD &dwLenInChar // length in TCHAR (if szCodeData == NULL then return length include EOL)
) {
   if (!dwSize) {
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return FALSE;
   }
   DWORD dwNeedLen = ((((dwSize-1)/3)+1)<<2) + 1;
   if (szCodeData == NULL) {
      dwLenInChar = dwNeedLen;
      ::SetLastError(DISP_E_BUFFERTOOSMALL); // ERROR_INSUFFICIENT_BUFFER
      return TRUE;
   }
   if (!pData) {
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return FALSE;
   }
   if (!szCodeData || (dwLenInChar < dwNeedLen)) {
      dwLenInChar = dwNeedLen;
      ::SetLastError(DISP_E_BUFFERTOOSMALL); // ERROR_INSUFFICIENT_BUFFER
      return FALSE;
   }

   szCodeData[dwNeedLen-1] = 0; // EOL

   const static TCHAR base64ABC[] = _T("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
   DWORD j = 0;
   DWORD i = 0;
   /** /
   //     2 .
   //       (   ) -
   //      .
   for (; i<dwSize; i+=3)
   {
      LONG l = (                    ((LONG)pData[i  ])<<16      ) |
               (((i+1) < dwSize) ? (((LONG)pData[i+1])<<8 ) : 0 ) |
               (((i+2) < dwSize) ? ( (LONG)pData[i+2]     ) : 0 );
                        szCodeData[j++] = base64ABC[(l>>18) & 0x3F];
                        szCodeData[j++] = base64ABC[(l>>12) & 0x3F];
      if (i+1 < dwSize) szCodeData[j++] = base64ABC[(l>> 6) & 0x3F];
      if (i+2 < dwSize) szCodeData[j++] = base64ABC[(l    ) & 0x3F];
   }
   /**/
   for (; dwSize>2 && i<dwSize-2; i+=3) {
      LONG l = (((LONG)pData[i  ])<<16) |
               (((LONG)pData[i+1])<<8 ) |
                 (LONG)pData[i+2];
      szCodeData[j++] = base64ABC[(l>>18) & 0x3F];
      szCodeData[j++] = base64ABC[(l>>12) & 0x3F];
      szCodeData[j++] = base64ABC[(l>> 6) & 0x3F];
      szCodeData[j++] = base64ABC[(l    ) & 0x3F];
   }
   if (i<dwSize) {
      LONG l = (                    ((LONG)pData[i  ])<<16      ) |
               (((i+1) < dwSize) ? (((LONG)pData[i+1])<<8 ) : 0 );
                        szCodeData[j++] = base64ABC[(l>>18) & 0x3F];
                        szCodeData[j++] = base64ABC[(l>>12) & 0x3F];
      if (i+1 < dwSize) szCodeData[j++] = base64ABC[(l>> 6) & 0x3F];
   }
   /**/
   switch (dwSize%3) {
   case 1: szCodeData[j++] = _T('=');
   case 2: szCodeData[j++] = _T('=');
   }
   dwLenInChar = j;

   ::SetLastError(NO_ERROR);
   return TRUE;
}

__forceinline int IndexB64(TCHAR c) {
   if ((c >= _T('A')) && (c <= _T('Z'))) return c-_T('A');
   if ((c >= _T('a')) && (c <= _T('z'))) return c-_T('a')+26;
   if ((c >= _T('0')) && (c <= _T('9'))) return c-_T('0')+52;
   if (c == _T('+')) return 62;
   if (c == _T('/')) return 63;
   return -1;
}

BOOL Base64_Decode(
   IN LPCTSTR szIn,  //    -  
   IN int iLenIn,    //   .  == -1,    ...
   OUT BYTE *pData,  //   -  
   IN OUT DWORD &dwSize // IN -  ; OUT -   
) {                     //  dwSize==0 -    
   if (!szIn || !szIn[0]) {
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return FALSE;
   }

   if (iLenIn == -1) {
      iLenIn = lstrlen(szIn);
   }
   DWORD dwNeedSize = (iLenIn>>2)*3 -
                      (szIn[iLenIn-1]==_T('=') ? 1 : 0) -
                      (szIn[iLenIn-2]==_T('=') ? 1 : 0);

   if (pData == NULL) {
      dwSize = dwNeedSize;
      ::SetLastError(DISP_E_BUFFERTOOSMALL); // ERROR_INSUFFICIENT_BUFFER
      return TRUE;
   }
   if (dwSize < dwNeedSize) {
      dwSize = dwNeedSize;
      ::SetLastError(DISP_E_BUFFERTOOSMALL); // ERROR_INSUFFICIENT_BUFFER
      return FALSE;
   }
   if (iLenIn < 4) {
      //    - 4 
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return FALSE;
   }

   const static TCHAR base64ABC[] = _T("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");

   dwSize = 0;
   int i=0;
   /** /
   //     2 .
   //       (   ) -
   //      .
   for (; i<iLenIn; i+=4) {
      bool in0=true , in1=false, in2=false, in3=false; //      
      bool bE0=false, bE1=false, bE2=false, bE3=false; //    "="
      int  iF0=0    , iF1=0    , iF2=0    , iF3=0    ; //     (,     Base64 )

      LONG l = ((in0 = (i+0) < iLenIn) && (bE0 = (szIn[i+0] != _T('='))) ? LONG(iF0 = IndexB64(szIn[i  ])) << 18 : 0) |
               ((in1 = (i+1) < iLenIn) && (bE1 = (szIn[i+1] != _T('='))) ? LONG(iF1 = IndexB64(szIn[i+1])) << 12 : 0) |
               ((in2 = (i+2) < iLenIn) && (bE2 = (szIn[i+2] != _T('='))) ? LONG(iF2 = IndexB64(szIn[i+2])) << 6  : 0) |
               ((in3 = (i+3) < iLenIn) && (bE3 = (szIn[i+3] != _T('='))) ? LONG(iF3 = IndexB64(szIn[i+3])) << 0  : 0);
      if ((iF0 == -1) || (iF1 == -1) || (iF2 == -1) || (iF3 == -1)) { //    ""    Base64 ...
         ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
         return TRUE; //    CryptStringToBinary...
      }

      if (in0 && bE0 && bE1) pData[dwSize++] = (BYTE(l>>16) & 0xFF);
      if (in1 && bE1 && bE2) pData[dwSize++] = (BYTE(l>>8 ) & 0xFF);
      if (in2 && bE2 && bE3) pData[dwSize++] = (BYTE(l>>0 ) & 0xFF);
   }
   /**/
   for (; i<iLenIn-5; i+=4) {
      int iF0=0, iF1=0, iF2=0, iF3=0; //     (,     Base64 )

      LONG l = (LONG(iF0 = IndexB64(szIn[i  ])) << 18) |
               (LONG(iF1 = IndexB64(szIn[i+1])) << 12) |
               (LONG(iF2 = IndexB64(szIn[i+2])) << 6 ) |
                LONG(iF3 = IndexB64(szIn[i+3]));
      if ((iF0 == -1) || (iF1 == -1) || (iF2 == -1) || (iF3 == -1)) { //    ""    Base64 ...
         ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
         return TRUE; //    CryptStringToBinary...
      }

      pData[dwSize++] = (BYTE(l>>16) & 0xFF);
      pData[dwSize++] = (BYTE(l>>8 ) & 0xFF);
      pData[dwSize++] = (BYTE(l>>0 ) & 0xFF);
   }
   {
      bool bE0=false, bE1=false, bE2=false, bE3=false; //    "="
      int  iF0=0    , iF1=0    , iF2=0    , iF3=0    ; //     (,     Base64 )

      LONG l = ((bE0 = (szIn[i+0] != _T('='))) ? LONG(iF0 = IndexB64(szIn[i  ])) << 18 : 0) |
               ((bE1 = (szIn[i+1] != _T('='))) ? LONG(iF1 = IndexB64(szIn[i+1])) << 12 : 0) |
               ((bE2 = (szIn[i+2] != _T('='))) ? LONG(iF2 = IndexB64(szIn[i+2])) << 6  : 0) |
               ((bE3 = (szIn[i+3] != _T('='))) ? LONG(iF3 = IndexB64(szIn[i+3])) << 0  : 0);
      if ((iF0 == -1) || (iF1 == -1) || (iF2 == -1) || (iF3 == -1)) { //    ""    Base64 ...
         ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
         return TRUE; //    CryptStringToBinary..
      }

      if (bE0 && bE1) pData[dwSize++] = (BYTE(l>>16) & 0xFF);
      if (bE1 && bE2) pData[dwSize++] = (BYTE(l>>8 ) & 0xFF);
      if (bE2 && bE3) pData[dwSize++] = (BYTE(l>>0 ) & 0xFF);
   }
   /**/
   ::SetLastError(NO_ERROR);
   return TRUE;
}

CString Base64_Code(
   IN LPCTSTR szIn //    - ,   
) {
   CString strOut; //   -  

   if (!szIn || !szIn[0]) {
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return strOut;
   }

   DWORD dwSizeInBytes = lstrlen(szIn) << (sizeof(TCHAR)-1);
   DWORD dwNeed = 0;
   BOOL bRes = Base64_Code(NULL, dwSizeInBytes, NULL, dwNeed); //     (c EOL)
   if (bRes) {
      TCHAR *szCodeData = new TCHAR[dwNeed];
      if (szCodeData == NULL) {
         ::SetLastError(ERROR_OUTOFMEMORY);
      } else {
         bRes = Base64_Code((BYTE*)szIn, dwSizeInBytes, szCodeData, dwNeed);
         if (bRes) {
            strOut = szCodeData;
         }
         delete [] szCodeData; szCodeData = NULL;
      }
   }
   return strOut;
}

CString Base64_Decode(
   IN LPCTSTR szIn //    -  
) {
   CString strOut;  //   -  
   if (!szIn || !szIn[0]) {
      ::SetLastError(ERROR_INVALID_DATA); // ERROR_INVALID_PARAMETER
      return strOut;
   }

   DWORD dwSizeInChar = lstrlen(szIn);
   DWORD dwNeed = 0;
   BOOL bRes = Base64_Decode(szIn, dwSizeInChar, NULL, dwNeed);
   if (bRes) {
      BYTE *pDecodeBuff = new BYTE[dwNeed];
      if (pDecodeBuff == NULL) {
         ::SetLastError(ERROR_OUTOFMEMORY);
      } else {
         ((TCHAR*)pDecodeBuff)[dwNeed-1] = 0;
         bRes = Base64_Decode(szIn, dwSizeInChar, pDecodeBuff, dwNeed);
         if (bRes) {
            strOut = CString((TCHAR*)pDecodeBuff, dwNeed>>(sizeof(TCHAR)-1));
         }
         delete [] pDecodeBuff; pDecodeBuff = NULL;
      }
   }
   return strOut;
}

CString SelectFile(BOOL bOpenDialog, HWND hWndOwner, LPCTSTR szDefSelectedFile, LPCTSTR szDefExt, LPCTSTR szFilter, LPCTSTR szTitle, LPCTSTR szInitialDir, DWORD dwFlags) {
   CString strFileName;
   DWORD nMaxFile = max(MAX_PATH, (szDefSelectedFile ? lstrlen(szDefSelectedFile)+1 : 0));
anew1:
   TCHAR *szFile = new TCHAR [nMaxFile];
anew2:
   if (szFile == NULL) {
      ::SetLastError(ERROR_OUTOFMEMORY);
   } else {
      szFile[0] = 0;
      if (szDefSelectedFile) {
         lstrcpyn(szFile, szDefSelectedFile, min(nMaxFile, (DWORD)lstrlen(szDefSelectedFile)+1));
      }
      OPENFILENAME OpenFileName = {
         sizeof(OPENFILENAME), // DWORD         lStructSize;
         hWndOwner           , // HWND          hwndOwner;
         NULL                , // HINSTANCE     hInstance;
         szFilter            , // LPCTSTR       lpstrFilter;
         NULL                , // LPTSTR        lpstrCustomFilter;
         0                   , // DWORD         nMaxCustFilter;
         0                   , // DWORD         nFilterIndex;
         szFile              , // LPTSTR        lpstrFile;
         nMaxFile            , // DWORD         nMaxFile;
         NULL                , // LPTSTR        lpstrFileTitle;
         0                   , // DWORD         nMaxFileTitle;
         szInitialDir        , // LPCTSTR       lpstrInitialDir;
         szTitle             , // LPCTSTR       lpstrTitle;
         dwFlags             , // DWORD         Flags;
         0                   , // WORD          nFileOffset;
         0                   , // WORD          nFileExtension;
         szDefExt            , // LPCTSTR       lpstrDefExt;
         0                   , // LPARAM        lCustData;
         NULL                , // LPOFNHOOKPROC lpfnHook;
         NULL                  // LPCTSTR       lpTemplateName;
      };
      if (bOpenDialog ? ::GetOpenFileName(&OpenFileName) : ::GetSaveFileName(&OpenFileName)) {
         strFileName = szFile;
      } else {
         DWORD dwError = ::CommDlgExtendedError();
         switch (dwError) {
         case FNERR_BUFFERTOOSMALL:
            {
             //nMaxFile = nMaxFile << 1;
               nMaxFile = *(short*)szFile;// first 2 bytes of the buffer pointed to by the lpstrFile member are set to an integer value specifying the size required to receive the full name.
               delete [] szFile; szFile = NULL;
               goto anew1;
            } break;
         case FNERR_INVALIDFILENAME:
            {
               szDefSelectedFile = NULL;
               goto anew2;
            } break;
         }
      }
      delete [] szFile; szFile = NULL;
   }
   return strFileName;
}

CString SelectFolder(
   HWND hWndOwner,   //    
   LPCTSTR szTitle,
   DWORD dwFlags,
   int nFolder)      //  -1 -      
                     //  CSIDL_... ( , see SHGetSpecialFolderLocation) -   
{
   CString strFolder;
   IMalloc *pMalloc = NULL;
#if (_WIN32_WINNT >= 0x0400 ) || defined(_WIN32_DCOM) // DCOM
   HRESULT hRes = ::CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
#endif // DCOM
   if (::SHGetMalloc(&pMalloc) == NOERROR) {
      ITEMIDLIST *pIIdL = NULL;
      TCHAR szFolder[MAX_PATH] = {0};
      if (nFolder == -1) {
         BROWSEINFO bi = {
            hWndOwner      , // HWND            hwndOwner;
            NULL           , // LPCITEMIDLIST   pidlRoot;
            szFolder       , // LPTSTR          pszDisplayName;
            szTitle        , // LPCTSTR         lpszTitle;
            dwFlags        , // UINT            ulFlags;
            NULL           , // BFFCALLBACK     lpfn;
            0              , // LPARAM          lParam;
            0                // int             iImage;
         };
         ITEMIDLIST *pIIdL = ::SHBrowseForFolder(&bi);
         if (pIIdL != NULL) {
            strFolder = szFolder; //   
            if (::SHGetPathFromIDList(pIIdL, szFolder)) {
               strFolder = szFolder; //  
            }
         }
      } else {
         if (::SHGetSpecialFolderLocation(hWndOwner, nFolder, &pIIdL) == NOERROR) {
            if (::SHGetPathFromIDList(pIIdL, szFolder)) {
               strFolder = szFolder; //  
            }
         }
      }
      if (pIIdL) {
         pMalloc->Free(pIIdL); pIIdL = NULL;
      }
      pMalloc->Release(); pMalloc = NULL;
   }
   return strFolder;
}

//  
LONGLONG GetFileSizeEx(LPCTSTR szFileName) {
   LONGLONG llSize = INVALID_FILE_SIZE;
   DWORD dwErrCode = ERROR_SUCCESS;
   if (FileExist(szFileName)) {
      HANDLE hFile = ::CreateFile(
         szFileName,
         GENERIC_READ,
         FILE_SHARE_READ,
         NULL,
         OPEN_EXISTING,
         FILE_ATTRIBUTE_NORMAL,
         NULL
      );
      if (hFile == INVALID_HANDLE_VALUE) {
         dwErrCode = ::GetLastError();
      } else {
         DWORD dwSizeHigh = 0;
         DWORD dwSizeLow  = ::GetFileSize(hFile, &dwSizeHigh);
         dwErrCode = ::GetLastError();
         if ((dwSizeLow == INVALID_FILE_SIZE) &&
             (dwErrCode != NO_ERROR))
         {
            // error!
         } else {
            dwErrCode = ERROR_SUCCESS;
            llSize = MAKELONGLONG(dwSizeLow, dwSizeHigh);
         }
         ::CloseHandle(hFile); hFile = NULL;
      }
   } else {
      dwErrCode = ERROR_FILE_NOT_FOUND;
   }
   ::SetLastError(dwErrCode);
   return llSize;
}

//  
DWORD GetFileSize(LPCTSTR szFileName) {
   DWORD dwSize = INVALID_FILE_SIZE;
   DWORD dwErrCode = ERROR_SUCCESS;
   if (FileExist(szFileName)) {
      HANDLE hFile = ::CreateFile(
         szFileName,
         GENERIC_READ,
         FILE_SHARE_READ,
         NULL,
         OPEN_EXISTING,
         FILE_ATTRIBUTE_NORMAL,
         NULL
      );
      if (hFile == INVALID_HANDLE_VALUE) {
         dwErrCode = ::GetLastError();
      } else {
         dwSize = ::GetFileSize(hFile, NULL);
         if (dwSize == INVALID_FILE_SIZE) {
            dwErrCode = ::GetLastError();
         }
         ::CloseHandle(hFile); hFile = NULL;
      }
   } else {
      dwErrCode = ERROR_FILE_NOT_FOUND;
   }
   ::SetLastError(dwErrCode);
   return dwSize;
}

//         (     )
CString GetFileDir(LPCTSTR szFullFileName) {
   CString strRes;
   if (szFullFileName == NULL) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
   } else {
#ifndef __EXCLUDE_CRT__
      TCHAR szDrive[_MAX_DRIVE] = {0};
      TCHAR szDir  [_MAX_DIR  ] = {0};
      TCHAR szFName[_MAX_FNAME] = {0};
      TCHAR szExt  [_MAX_EXT  ] = {0};
   #ifdef _tsplitpath_s
      _tsplitpath_s(szFullFileName, szDrive, _MAX_DRIVE, szDir, _MAX_DIR, szFName, _MAX_FNAME, szExt, _MAX_EXT);
   #else
      _tsplitpath(szFullFileName, szDrive, szDir, szFName, szExt);
   #endif
      if (szDrive[0]) {
         strRes = szDrive;
         strRes += szDir[0] ? szDir : _T("\\");
      } else
#endif __EXCLUDE_CRT__
      {
         //  
         strRes = szFullFileName;
         int iFind = strRes.ReverseFind(_T('\\'));
         if (iFind != -1) {
            strRes = strRes.Left(iFind+1);
         } else {
            iFind = strRes.ReverseFind(_T('/'));
            if (iFind != -1) {
               strRes = strRes.Left(iFind+1);
            } else {
               if (!strRes.IsEmpty()) {
                  strRes += _T("\\");
               }
               //strRes.Empty();
               //::SetLastError(ERROR_INVALID_PARAMETER);
            }
         }
      }
   }
   return strRes;
}

//      
CString GetFileName(LPCTSTR szFullFileName) {
   CString strRes;
   if (szFullFileName == NULL) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
   } else {
#ifndef __EXCLUDE_CRT__
      TCHAR szDrive[_MAX_DRIVE] = {0};
      TCHAR szDir  [_MAX_DIR  ] = {0};
      TCHAR szFName[_MAX_FNAME] = {0};
      TCHAR szExt  [_MAX_EXT  ] = {0};
   #ifdef _tsplitpath_s
      _tsplitpath_s(szFullFileName, szDrive, _MAX_DRIVE, szDir, _MAX_DIR, szFName, _MAX_FNAME, szExt, _MAX_EXT);
   #else
      _tsplitpath(szFullFileName, szDrive, szDir, szFName, szExt);
   #endif
      if (szFullFileName[0] || szFName[0]) {
         strRes = szFName;
         strRes += szExt;
      } else
#endif __EXCLUDE_CRT__
      {
         //  
         strRes = szFullFileName;
         int iFind = strRes.ReverseFind(_T('\\'));
         if (iFind != -1) {
            strRes = strRes.Right(strRes.GetLength()-(iFind+1));
         } else {
            iFind = strRes.ReverseFind(_T('/'));
            if (iFind != -1) {
               strRes = strRes.Right(strRes.GetLength()-(iFind+1));
            } else {
               //strRes.Empty();
               //::SetLastError(ERROR_INVALID_PARAMETER);
            }
         }
      }
   }
   return strRes;
}

CString GetFileVersion(LPCTSTR szFileName, OUT WORD *pwVerMSHigh, OUT WORD *pwVerMSLow, OUT WORD *pwVerLSHigh, OUT WORD *pwVerLSLow) {
   CString strRes;
   DWORD dwErrCode = ERROR_SUCCESS;
   if (!FileExist(szFileName)) {
      dwErrCode = ::GetLastError();
   } else {
      DWORD dwSize = ::GetFileVersionInfoSize(szFileName, 0);
      if (dwSize == 0) {
         dwErrCode = ::GetLastError();
      } else {
         BYTE *pData = new BYTE [dwSize];
         if (pData == NULL) {
            dwErrCode = ERROR_OUTOFMEMORY;
         } else {
            BOOL bRes = ::GetFileVersionInfo(szFileName, 0, dwSize, pData);
            if (!bRes ) {
               dwErrCode = ::GetLastError();
            } else {
               VS_FIXEDFILEINFO *pFixeFileInfo = NULL;
               UINT uLen = 0;
               bRes = ::VerQueryValue(pData, _T("\\"), (void**)&pFixeFileInfo, &uLen);
               if (!bRes) {
                  dwErrCode = ::GetLastError();
               } else {
                  WORD v1 = HIWORD(pFixeFileInfo->dwFileVersionMS); if (pwVerMSHigh) { *pwVerMSHigh = v1; }
                  WORD v2 = LOWORD(pFixeFileInfo->dwFileVersionMS); if (pwVerMSLow ) { *pwVerMSLow  = v2; }
                  WORD v3 = HIWORD(pFixeFileInfo->dwFileVersionLS); if (pwVerLSHigh) { *pwVerLSHigh = v3; }
                  WORD v4 = LOWORD(pFixeFileInfo->dwFileVersionLS); if (pwVerLSLow ) { *pwVerLSLow  = v4; }
                  strRes.Format(_T("%i.%i.%i.%i"), int(v1),int(v2),int(v3),int(v4));
               }
            }
            delete [] pData; pData = NULL;
         }
      }
   }
   ::SetLastError(dwErrCode);
   return strRes;
}

CString GetWindowText(HWND hWnd) {
   CString strCaption;
   int iBuff = 1;
   TCHAR *szCaption = NULL;
   int iRes = 0;
   DWORD dwErrCode = ERROR_SUCCESS;
   do {
      szCaption = new TCHAR[iBuff = iBuff<<1];
      if (szCaption == NULL) {
         dwErrCode = ERROR_OUTOFMEMORY;
         break;
      } else {
         szCaption[0] = 0;
         ::SetLastError(ERROR_SUCCESS);
         iRes = ::GetWindowText(hWnd, szCaption, iBuff);
         dwErrCode = ::GetLastError();
         BOOL bBreak = FALSE;
         if ((iRes==0) || (iRes < (iBuff-1))) {
            strCaption = szCaption;
            bBreak = TRUE;
         }
         delete [] szCaption; szCaption = NULL;
         if (bBreak) break;
      }
   } while(true);
   ::SetLastError(dwErrCode);
   return strCaption;
   /** /
   CString strCaption;
   DWORD dwErrCode = ERROR_SUCCESS;
   int iLen = ::GetWindowTextLength(hWnd);
   if (iLen == 0) {
      dwErrCode = ::GetLastError();
   } else {
      TCHAR *szCaption = new TCHAR[iLen+1];
      if (szCaption == NULL) {
         dwErrCode = ERROR_OUTOFMEMORY;
      } else {
         szCaption[iLen] = 0;
         int iRes = ::GetWindowText(hWnd, szCaption, iLen);
         if (iRes!=iLen) {
            dwErrCode = ::GetLastError();
         } else {
            strCaption = szCaption;
         }
         delete [] szCaption; szCaption = NULL;
      }
   }
   ::SetLastError(dwErrCode);
   return strCaption;
   /**/
}

CString GetIPAdress() {
   CString strRes;

   // 1.    Internet Protocol Helper (IP Helper) API
   //    - GetAdaptersInfo
   ULONG ulOutBufLen = 0;
   DWORD dwErrCode = ::GetAdaptersInfo(NULL, &ulOutBufLen);
   if (dwErrCode == ERROR_BUFFER_OVERFLOW) {
      PIP_ADAPTER_INFO pInfo = (PIP_ADAPTER_INFO) new BYTE [ulOutBufLen];
      if (pInfo == NULL) {
         dwErrCode = ERROR_OUTOFMEMORY;
      } else {
         dwErrCode = ::GetAdaptersInfo(pInfo, &ulOutBufLen);
         if (dwErrCode == ERROR_SUCCESS) {
            strRes = pInfo->IpAddressList.IpAddress.String;
         }
         delete [] pInfo; pInfo = NULL;
      }
   }

   // 2.    Windows Sockets 2 API
   //    - gethostname  gethostbyname
   if (strRes.IsEmpty()) {
      HOSTENT *he = NULL;
      BYTE *IP = NULL;
      char name[0xFF];

      if (0 != ::gethostname(name, sizeof(name))) {
         dwErrCode = ::WSAGetLastError();
      } else {
         he = ::gethostbyname(name);
         if (he == NULL) {
            dwErrCode = ::WSAGetLastError();
         } else {
            IP = (BYTE *)he->h_addr_list[0];
         }
         if (IP) {
            strRes.Format(_T("%i.%i.%i.%i"), int(IP[0]), int(IP[1]), int(IP[2]), int(IP[3]));
         }
      }
   }

   ::SetLastError(dwErrCode);
   return strRes;
}

CString GetHostName() {
   HOSTENT *he = NULL;
   BYTE *IP = NULL;
   char name[0xFF];

   gethostname(name, sizeof(name));
   he = gethostbyname(name);
   return CString(he ? he->h_name : NULL);
}

HBITMAP CreateMask(HBITMAP hBmp, COLORREF colorTransparent) {
   HBITMAP hBmpMask = NULL;
   DWORD dwErrCode = NO_ERROR;
   SIZE sizeBmp = ::SizeBitmap(hBmp);
   if (!sizeBmp.cx || !sizeBmp.cy) {
      dwErrCode = ::GetLastError();
   } else {
      hBmpMask = ::CreateMono(sizeBmp);
      if (!hBmpMask) {
         dwErrCode = ::GetLastError();
      } else {
         HDC hDC_Dst = ::CreateCompatibleDC(NULL);
         HDC hDC_Src = ::CreateCompatibleDC(NULL);
         HGDIOBJ hBmpSaveSrc = ::SelectObject(hDC_Src, hBmp);
         if (!hBmpSaveSrc) {
            //     hBmp     . HDC
            dwErrCode = ERROR_INVALID_OPERATION;//ERROR_RESOURCE_DISABLED;//ERROR_NO_SYSTEM_RESOURCES;//
            ::DeleteObject(hBmpMask); hBmpMask = NULL; //   ,  ...
         } else {
            HGDIOBJ hBmpSaveDst = ::SelectObject(hDC_Dst, hBmpMask);

            COLORREF oldBkColor = ::SetBkColor(hDC_Src, (colorTransparent == CLR_INVALID) ? ::GetPixel(hDC_Src, 0, 0) : colorTransparent);
            ::BitBlt(hDC_Dst, sizeBmp, hDC_Src, NOTSRCCOPY);
            ::SetBkColor(hDC_Src, oldBkColor);

            ::SelectObject(hDC_Dst, hBmpSaveDst);
            ::SelectObject(hDC_Src, hBmpSaveSrc);
         }
         ::DeleteDC(hDC_Dst);
         ::DeleteDC(hDC_Src);
      }
   }
   ::SetLastError(dwErrCode);
   return hBmpMask;
}

HBITMAP CreateRotatedBitmap(HBITMAP hBitmap, float angle, COLORREF clrBack) {
   typedef BOOL (WINAPI* PF_SetWorldTransform)(IN HDC, IN CONST XFORM *);
   static PF_SetWorldTransform func_SetWorldTransform = (PF_SetWorldTransform)::GetProcAddress(::LoadLibrary(_T("GDI32.dll")), "SetWorldTransform");

   if (func_SetWorldTransform == NULL) {
      ::SetLastError(ERROR_CALL_NOT_IMPLEMENTED);//ERROR_NOT_SUPPORTED);
      return FALSE;
   }

	// Create a memory DC compatible with the display
	HDC hDCSrc = ::CreateCompatibleDC(NULL);
   HDC hDCDst = ::CreateCompatibleDC(NULL);

	// Get logical coordinates
	BITMAP bm;
	int iRes = ::GetObject(hBitmap, sizeof(bm), &bm);

	float cosine = (float)cos(angle);
	float sine = (float)sin(angle);

	// Compute dimensions of the resulting bitmap
	// First get the coordinates of the 3 corners other than origin
	int x1 = (int)( bm.bmHeight * sine);
	int y1 = (int)( bm.bmHeight * cosine);
	int x2 = (int)( bm.bmWidth  * cosine + bm.bmHeight * sine);
	int y2 = (int)( bm.bmHeight * cosine - bm.bmWidth  * sine);
	int x3 = (int)( bm.bmWidth  * cosine);
	int y3 = (int)(-bm.bmWidth  * sine);

	int minx = min(0,min(x1, min(x2,x3)));
	int miny = min(0,min(y1, min(y2,y3)));
	int maxx = max(0,max(x1, max(x2,x3)));
	int maxy = max(0,max(y1, max(y2,y3)));

   SIZE sizeOut = {maxx - minx, maxy - miny};

	// Create a bitmap to hold the result
	HBITMAP hBmpRes = ::CreateCompatibleBitmap(hBitmap, sizeOut.cx, sizeOut.cy);

	HGDIOBJ hBmpSrcOld = ::SelectObject(hDCSrc, hBitmap);
	HGDIOBJ hBmpDstOld = ::SelectObject(hDCDst, hBmpRes);

	// Draw the background color before we change mapping mode
   {
      if (clrBack == CLR_INVALID) {
         clrBack = ::GetPixel(hDCSrc, 0,0);
      }
      HBRUSH  hBrNew = ::CreateSolidBrush(clrBack);
      HGDIOBJ hBrOld = ::SelectObject(hDCDst, hBrNew);
      BOOL bRes = ::PatBlt(hDCDst, 0, 0, sizeOut.cx, sizeOut.cy, PATCOPY);
      ::SelectObject(hDCDst, hBrOld);
      bRes = ::DeleteObject(hBrNew);
   }

	// We will use world transform to rotate the bitmap
   {
      iRes = ::SetGraphicsMode(hDCDst, GM_ADVANCED);
      XFORM xform = {
         cosine,        // FLOAT   eM11
        -sine,          // FLOAT   eM12
         sine,          // FLOAT   eM21
         cosine,        // FLOAT   eM22
         (float)-minx,  // FLOAT   eDx
         (float)-miny}; // FLOAT   eDy
	   BOOL bRes = func_SetWorldTransform(hDCDst, &xform);
   }

	// Now do the actual rotating - a pixel at a time
	BOOL bRes = ::BitBlt(hDCDst, 0,0,bm.bmWidth, bm.bmHeight, hDCSrc, 0, 0, SRCCOPY);

	// Restore DCs
	::SelectObject(hDCSrc, hBmpSrcOld);
	::SelectObject(hDCDst, hBmpDstOld);

   // free
   ::DeleteDC(hDCDst);
   ::DeleteDC(hDCSrc);

	return hBmpRes;
}

CString MemCopyAsHex(LPCVOID pData, DWORD dwSize, BOOL bUsePrefix, LPCTSTR szSeparator)
{
   /*
   //      
   CString strRes;
   for (DWORD i=0; i<dwSize; i++) {
      if (szSeparator && szSeparator[0]) {
         strRes += szSeparator;
      }
      strRes += ::Format(bUsePrefix ? _T("0x%02X") : _T("%02X"), int(((BYTE*)pData)[i]));
   }
   if (!strRes.IsEmpty() && szSeparator && szSeparator[0]) {
      strRes = strRes.Mid(lstrlen(szSeparator));
   }
   /**/
   if (!pData || !dwSize) return _T("");
   int iMaxCharIndex = (dwSize<<1) + (bUsePrefix ? (dwSize<<1) : 0) + ((szSeparator && szSeparator[0])?(lstrlen(szSeparator)*(dwSize-1)):0);
   CString strRes(_T('\0'), iMaxCharIndex+1);
   int j=0;
   for (size_t i=0; i<dwSize; i++) {
      if (bUsePrefix) {
         strRes.SetAt(j++, _T('0'));
         strRes.SetAt(j++, _T('x'));
      }

      BYTE bH = ((BYTE*)pData)[i] >> 4;
      BYTE bL = ((BYTE*)pData)[i] & 0x0F;

      TCHAR ch = (bH < 10) ? (_T('0')+bH) : (_T('A')+(bH-10));
      strRes.SetAt(j++, ch);

      ch = (bL < 10) ? (_T('0')+bL) : (_T('A')+(bL-10));
      strRes.SetAt(j++, ch);

      if ((i<dwSize-1) && szSeparator && szSeparator[0]) {
         for (int k=0; *(szSeparator+k); k++) {
            strRes.SetAt(j++, szSeparator[k]);
         }
      }
   }
   return strRes;
}

CHAR ToChar(WCHAR ch) {
   WCHAR wszData[2] = {ch, L'\0'};
   CHAR szData[2] = {'\0', '\0'};
   int iRes = ::WideCharToMultiByte(CP_ACP, 0, wszData, 1, szData, 2, NULL, NULL);
   return (iRes == 0) ? ' ' : szData[0];
}

CString MemCopyAsString(LPCVOID pData, DWORD dwSize, TCHAR chSeparatorEOL, BOOL bUnicode) {
   CString strRes;
   if (pData && dwSize) {
      //bUnicode = ::IsTextUnicode(pData, dwSize, NULL);
      if (bUnicode) {
         LPWSTR szBuff = (LPWSTR) new BYTE[dwSize+2+(dwSize&1)];
         if (szBuff) {
            memcpy(szBuff, pData, dwSize);
            memset(LPBYTE(szBuff)+dwSize, 0, 2+(dwSize&1));
            for (DWORD i=0; i<((dwSize+(dwSize&1))>>1); i++) {
               if (szBuff[i] == L'\0') {
                  szBuff[i] = chSeparatorEOL;
               }
            }
            strRes = szBuff;
            delete [] szBuff; szBuff = NULL;
         }
      } else {
         LPSTR szBuff = (LPSTR) new BYTE[dwSize+1];
         if (szBuff) {
            memcpy(szBuff, pData, dwSize);
            szBuff[dwSize] = 0; // EOL
            for (DWORD i=0; i<dwSize; i++) {
               if (szBuff[i] == '\0') {
               #ifdef UNICODE
                  szBuff[i] = ToChar(chSeparatorEOL);
               #else
                  szBuff[i] = chSeparatorEOL;
               #endif
               }
            }
            strRes = szBuff;
            delete [] szBuff; szBuff = NULL;
         }
      }
   }
   return strRes;
}

BOOL SerializeRead(IN HANDLE hFile, OUT CString &str, UINT iMaxLength) {
   UINT iLen = 0;
   DWORD dwNOBR = 0;
   BOOL bRes = ::ReadFile(hFile, &iLen, sizeof(iLen), &dwNOBR, NULL) && (sizeof(iLen) == dwNOBR);
   if (bRes) {
      if (iLen == 0) {
         str.Empty();
      } else {
         if (iLen > iMaxLength) {
            bRes = FALSE;
   #ifdef _DEBUG
            //_ASSERTE((_T(" .\r\n\r\n- SerializeRead.\r\n      ."), FALSE));
            ::MessageBox(::GetActiveWindow(), _T("- SerializeRead.\r\n      ."), _T(" "), MB_OK | MB_ICONWARNING);
   #endif
         } else {
            BOOL bUnicode;
            bRes = ::ReadFile(hFile, &bUnicode, sizeof(bUnicode), &dwNOBR, NULL) && (sizeof(bUnicode) == dwNOBR);
            if (bRes) {
               UINT iSizeChar = bUnicode ? sizeof(WCHAR) : sizeof(CHAR);
               UINT iSizeBuff = (iLen+1)<<(bUnicode ? 1 : 0); // in bytes (+1 - EOL char)
               BYTE *szBuff = new BYTE[iSizeBuff];
               bRes = !!szBuff;
               if (bRes) {
                  szBuff[iSizeBuff-1] = 0; // EOL
                  if (bUnicode) {
                     szBuff[iSizeBuff-2] = 0; // EOL
                  }
                  bRes = ::ReadFile(hFile, szBuff, iSizeBuff-iSizeChar, &dwNOBR, NULL) && (iSizeBuff-iSizeChar == dwNOBR);
                  if (bRes) {
                     if (bUnicode) {
                        str = (LPCWSTR)szBuff;
                     } else {
                        str = (LPCSTR)szBuff;
                     }                     
                  }
                  delete [] szBuff; szBuff = NULL;
               }
            }
         }
      }
   }
   return bRes;
}

BOOL SerializeWrite(IN HANDLE hFile, IN const CString &str) {
   int iLen = str.GetLength();
   DWORD dwNOBW = 0;
   BOOL bRes = ::WriteFile(hFile, &iLen, sizeof(iLen), &dwNOBW, NULL) && (sizeof(iLen) == dwNOBW);
   if (bRes && iLen) {
#ifdef _UNICODE
      BOOL bUnicode = TRUE;
#else
      BOOL bUnicode = FALSE;
#endif
      bRes = (::WriteFile(hFile,    &bUnicode,        sizeof(bUnicode), &dwNOBW, NULL) &&         (sizeof(bUnicode ) == dwNOBW)) &&
             (::WriteFile(hFile, (LPCTSTR)str, iLen<<(sizeof(TCHAR)-1), &dwNOBW, NULL) && ((iLen<<(sizeof(TCHAR)-1)) == dwNOBW));
   }
   return bRes;
}

void BeepSpeaker(DWORD dwFreq, DWORD dwDuration)
{
   dwFreq = min(max(0x25, dwFreq), 0x7FFF);
   static OSVERSIONINFO OsVersion = {
      sizeof(OSVERSIONINFO), // DWORD dwOSVersionInfoSize;
      0,                     // DWORD dwMajorVersion;
      0,                     // DWORD dwMinorVersion;
      0,                     // DWORD dwBuildNumber;
      0,                     // DWORD dwPlatformId;
      {_T('\0'),}            // TCHAR szCSDVersion[128];
   };
   static BOOL bRes = ::GetVersionEx(&OsVersion);

   /* We need to check if we're running on NT, because NT
   does not allow the "out" assembler command for security
   reasons and the Beep API function works via the speaker on NT,
   so that's ok.
   On Windows 9x Beep will sound the default system
   beep which is in most cases through the soundblaster.
   (frequency is not supported under Windows 9x) */

   if (OsVersion.dwPlatformId == VER_PLATFORM_WIN32_NT) {
      ::Beep(dwFreq, dwDuration);
   } else { //VER_PLATFORM_WIN32_WINDOWS
      __asm
      {
         mov al, -1
         out 61h, al
      }
      Sleep(dwDuration);
      __asm
      {
         mov al, 0
         out 61h, al
      }
   }
}

////////////////////////////////////////////////////////////////////////////////

inline RECT MaxMinXY(const POINT *pP, int nCount) {
   RECT rc = {0,0,0,0};
   for (int i=0; pP && i<nCount; i++) {
      if (rc.left   > pP[i].x) rc.left   = pP[i].x;
      if (rc.top    > pP[i].y) rc.top    = pP[i].y;
      if (rc.right  < pP[i].x) rc.right  = pP[i].x;
      if (rc.bottom < pP[i].y) rc.bottom = pP[i].y;
   }
   return rc;
}

BOOL StretchBltMasked(HDC hDCDst, RECT const &rcDst, HDC hDCSrc, RECT const &rcSrc, HDC hDCMsk, RECT const &rcMsk) {
   DWORD dwErrCode = NO_ERROR;
   
   COLORREF oldBkColor   = ::SetBkColor  (hDCDst, RGB(255, 255, 255));
   COLORREF oldTextColor = ::SetTextColor(hDCDst, RGB(0, 0, 0));
   BOOL bRes = ::SetStretchBltMode(hDCDst, COLORONCOLOR) &&
               ::StretchBlt(hDCDst, rcDst, hDCSrc, rcSrc, DSx ) &&
               ::StretchBlt(hDCDst, rcDst, hDCMsk, rcMsk, DSna) &&
               ::StretchBlt(hDCDst, rcDst, hDCSrc, rcSrc, DSx );
   if (!bRes) {
      dwErrCode = ::GetLastError();
   }
   ::SetBkColor  (hDCDst, oldBkColor);
   ::SetTextColor(hDCDst, oldTextColor);

   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL BitBltMasked(HDC hDCDst, RECT const &rcDst, HDC hDCSrc, POINT const &pLTSrc, HDC hDCMsk, POINT const &pLTMsk) {
   DWORD dwErrCode = NO_ERROR;

   COLORREF oldBkColor   = ::SetBkColor  (hDCDst, RGB(255, 255, 255));
   COLORREF oldTextColor = ::SetTextColor(hDCDst, RGB(0, 0, 0));
   BOOL bRes = ::BitBlt(hDCDst, rcDst, hDCSrc, pLTSrc, DSx ) &&
               ::BitBlt(hDCDst, rcDst, hDCMsk, pLTMsk, DSna) &&
               ::BitBlt(hDCDst, rcDst, hDCSrc, pLTSrc, DSx );
   if (!bRes) {
      dwErrCode = ::GetLastError();
   }
   ::SetBkColor  (hDCDst, oldBkColor);
   ::SetTextColor(hDCDst, oldTextColor);

   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL StretchBltMasked(HDC hDCDst, RECT const &rcDst, HBITMAP hBmpSrc, RECT const &rcSrc , COLORREF clrTransparent) {
   DWORD dwErrCode = NO_ERROR;
   
   HDC hDCSrc = ::CreateCompatibleDC(hDCDst);
   HDC hDCMsk = ::CreateCompatibleDC(hDCDst);
   HBITMAP hBmpMsk = ::CreateMask(hBmpSrc, clrTransparent);
   HGDIOBJ hBmpMskOld  = ::SelectObject(hDCMsk, hBmpMsk);
   HGDIOBJ hBmpSrcOld  = ::SelectObject(hDCSrc, hBmpSrc);

   BOOL bRes = ::StretchBltMasked(hDCDst, rcDst, hDCSrc, rcSrc, hDCMsk, rcSrc);
   if (!bRes) {
      dwErrCode = ::GetLastError();
   }

   ::SelectObject(hDCMsk, hBmpMsk);
   ::DeleteDC(hDCMsk);
   ::SelectObject(hDCSrc, hBmpSrc);
   ::DeleteDC(hDCSrc);
   ::DeleteObject(hBmpMsk);

   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL BitBltMasked(HDC hDCDst, RECT const &rcDst, HBITMAP hBmpSrc, POINT const &pLTSrc, COLORREF clrTransparent) {
   DWORD dwErrCode = NO_ERROR;

   // 1.    
   HDC hDCSrc = ::CreateCompatibleDC(hDCDst);
   HDC hDCMsk = ::CreateCompatibleDC(hDCDst);
   HBITMAP hBmpMsk = ::CreateMask(hBmpSrc, clrTransparent);
   HGDIOBJ hBmpMskOld  = ::SelectObject(hDCMsk, hBmpMsk);
   HGDIOBJ hBmpSrcOld  = ::SelectObject(hDCSrc, hBmpSrc);
   // 2.   
   BOOL bRes = ::BitBltMasked(hDCDst, rcDst, hDCSrc, pLTSrc, hDCMsk, pLTSrc);
   if (!bRes) {
      dwErrCode = ::GetLastError();
   }

   ::SelectObject(hDCMsk, hBmpMskOld);
   ::SelectObject(hDCSrc, hBmpSrcOld);
   ::DeleteObject(hBmpMsk);
   ::DeleteDC(hDCMsk);
   ::DeleteDC(hDCSrc);

   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL BitBltMasked(HDC hDCDst, RECT const &rcDst, HDC hDCSrc, POINT const &pLTSrc, COLORREF clrTransparent) {
   DWORD dwErrCode = NO_ERROR;
   
   // 1.   hDCSrc 
   HBITMAP hBmpSrc = ::CreateCompatibleBitmap(hDCSrc, rcDst.right-rcDst.left, rcDst.bottom-rcDst.top);
   {
      HDC hCDC = ::CreateCompatibleDC(hDCSrc);
      HGDIOBJ hBmpOld = ::SelectObject(hCDC, hBmpSrc);
      ::BitBlt(hCDC, 0,0,rcDst.right-rcDst.left, rcDst.bottom-rcDst.top, hDCSrc, pLTSrc.x,pLTSrc.y, SRCCOPY);
      ::SelectObject(hCDC, hBmpOld);
      ::DeleteDC(hCDC);
   }
   // 2.   
   BOOL bRes = BitBltMasked(hDCDst, rcDst, hBmpSrc, pLTSrc, clrTransparent);
   if (!bRes) {
      dwErrCode = ::GetLastError();
   }
   ::DeleteObject(hBmpSrc);

   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL StretchBltMasked(HDC hDCDst, RECT const &rcDst, HDC hDCSrc, RECT const &rcSrc, POINT const *pPointsMsk, int nCount, RECT const &rcMsk) {
   DWORD dwErrCode = NO_ERROR;
   
   HDC hDCMsk = ::CreateCompatibleDC(hDCDst);
   HBITMAP hBmpMsk = NULL;
   HGDIOBJ hBmpMskOld  = NULL;

   RECTEX rcMskFrame(MaxMinXY(pPointsMsk, nCount)); rcMskFrame.left = rcMskFrame.top = 0;

   BOOL bRes = !!(hBmpMsk = ::CreateBitmap(rcMskFrame.width(), rcMskFrame.height(), 1, 1, NULL)); //  bitmap  
   if (!bRes) {
      dwErrCode = ::GetLastError();
   } else {
      hBmpMskOld = ::SelectObject(hDCMsk, hBmpMsk); //       
      bRes = ::PatBlt(hDCMsk, 0,0, rcMskFrame.width(), rcMskFrame.height(), BLACKNESS); //  
      if (!bRes) {
         dwErrCode = ::GetLastError();
      } else {
         HGDIOBJ hBrushOld = ::SelectObject(hDCMsk, ::GetStockObject(WHITE_BRUSH));
         HGDIOBJ hPenOld   = ::SelectObject(hDCMsk, ::GetStockObject(NULL_PEN));
         bRes = ::Polygon(hDCMsk, pPointsMsk, nCount); //     
         if (!bRes) {
            dwErrCode = ::GetLastError();
         }
         ::SelectObject(hDCMsk, hBrushOld);
         ::SelectObject(hDCMsk, hPenOld);
      }
   }
   if (bRes) {
      bRes = ::StretchBltMasked(hDCDst, rcDst, hDCSrc, rcSrc, hDCMsk, rcMsk);
      if (!bRes) {
         dwErrCode = ::GetLastError();
      }
   }

   ::SelectObject(hDCMsk, hBmpMsk);
   ::DeleteDC(hDCMsk);
   ::DeleteObject(hBmpMsk);

   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL BitBltMasked(HDC hDCDst, RECT const &rcDst, HDC hDCSrc, POINT const &pLTSrc, POINT const *pPointsMsk, int nCount, POINT const &pLTMsk) {
   DWORD dwErrCode = NO_ERROR;
   
   HDC hDCMsk = ::CreateCompatibleDC(hDCDst);
   HBITMAP hBmpMsk = NULL;
   HGDIOBJ hBmpMskOld  = NULL;

   RECTEX rcMskFrame(MaxMinXY(pPointsMsk, nCount)); rcMskFrame.left = rcMskFrame.top = 0;

   BOOL bRes = !!(hBmpMsk = ::CreateBitmap(rcMskFrame.width(), rcMskFrame.height(), 1, 1, NULL)); //  bitmap  
   if (!bRes) {
      dwErrCode = ::GetLastError();
   } else {
      hBmpMskOld = ::SelectObject(hDCMsk, hBmpMsk); //       
      bRes = ::PatBlt(hDCMsk, 0,0, rcMskFrame.width(), rcMskFrame.height(), BLACKNESS); //  
      if (!bRes) {
         dwErrCode = ::GetLastError();
      } else {
         HGDIOBJ hBrushOld = ::SelectObject(hDCMsk, ::GetStockObject(WHITE_BRUSH));
         HGDIOBJ hPenOld   = ::SelectObject(hDCMsk, ::GetStockObject(NULL_PEN));
         bRes = ::Polygon(hDCMsk, pPointsMsk, nCount); //     
         if (!bRes) {
            dwErrCode = ::GetLastError();
         }
         ::SelectObject(hDCMsk, hBrushOld);
         ::SelectObject(hDCMsk, hPenOld);
      }
   }
   if (bRes) {
      bRes = ::BitBltMasked(hDCDst, rcDst, hDCSrc, pLTSrc, hDCMsk, pLTMsk);
      if (!bRes) {
         dwErrCode = ::GetLastError();
      }
   }

   ::SelectObject(hDCMsk, hBmpMsk);
   ::DeleteDC(hDCMsk);
   ::DeleteObject(hBmpMsk);

   ::SetLastError(dwErrCode);
   return bRes;
}

////////////////////////////////////////////////////////////////////////////////
//    begin class CRegistry
////////////////////////////////////////////////////////////////////////////////

#define BEGIN_REG_PARSE_PATH_EX(szPath, bPathWithValueName, bValidParam, bCreatePatch, regAccess) \
   DWORD dwErrCode = ERROR_SUCCESS; \
   if (!(szPath && (bValidParam))) { \
      dwErrCode = ERROR_INVALID_PARAMETER; \
   } else { \
      LPTSTR szPath2 = _tcsdup(szPath); \
      if (szPath2 == NULL) { \
         dwErrCode = ERROR_OUTOFMEMORY; \
      } else { \
         LPTSTR szHKey = szPath2, szSubKey = NULL, szValueName = NULL; \
         TCHAR *szPos1 = _tcschr(szPath2, _T('\\')); \
         if (szPos1) { \
            szPos1[0] = 0; \
            if (bPathWithValueName) { \
               TCHAR *szPos2 = _tcsrchr(szPos1+1, _T('\\')); \
               if (szPos2) { \
                  szPos2[0] = 0; \
                  szSubKey = szPos1+1; \
                  szValueName = szPos2+1; \
               } else { \
                  szValueName = szPos1+1; \
               } \
            } else { \
               szSubKey = szPos1+1; \
            } \
         } \
         HKEY hKey = NULL; \
         if (lstrcmpi(szHKey, _T("HKEY_CLASSES_ROOT"       )) == 0) hKey = HKEY_CLASSES_ROOT       ; else \
         if (lstrcmpi(szHKey, _T("HKEY_CURRENT_USER"       )) == 0) hKey = HKEY_CURRENT_USER       ; else \
         if (lstrcmpi(szHKey, _T("HKEY_LOCAL_MACHINE"      )) == 0) hKey = HKEY_LOCAL_MACHINE      ; else \
         if (lstrcmpi(szHKey, _T("HKEY_USERS"              )) == 0) hKey = HKEY_USERS              ; else \
         if (lstrcmpi(szHKey, _T("HKEY_PERFORMANCE_DATA"   )) == 0) hKey = HKEY_PERFORMANCE_DATA   ; else \
         if (lstrcmpi(szHKey, _T("HKEY_PERFORMANCE_NLSTEXT")) == 0) hKey = HKEY_PERFORMANCE_NLSTEXT; else \
         if (lstrcmpi(szHKey, _T("HKEY_PERFORMANCE_TEXT"   )) == 0) hKey = HKEY_PERFORMANCE_TEXT   ; else \
         if (lstrcmpi(szHKey, _T("HKEY_CURRENT_CONFIG"     )) == 0) hKey = HKEY_CURRENT_CONFIG     ; else \
         if (lstrcmpi(szHKey, _T("HKEY_DYN_DATA"           )) == 0) hKey = HKEY_DYN_DATA           ; else { \
            dwErrCode = ERROR_BAD_PATHNAME; /* ERROR_PATH_NOT_FOUND */ \
         } \
         if (hKey) { \
            if (szSubKey && szSubKey[0]) { \
               if (bCreatePatch) { \
                  dwErrCode = ::RegCreateKey(hKey, szSubKey, &hKey); \
               } else { \
                  dwErrCode = ::RegOpenKeyEx(hKey, szSubKey, 0, KEY_READ | regAccess, &hKey); \
               } \
            } \
            if (dwErrCode == ERROR_SUCCESS) {

#define END_REG_PARSE_PATH \
               dwErrCode = ::GetLastError(); \
               if (szSubKey && szSubKey[0]) { \
                  ::RegCloseKey(hKey); hKey = NULL; \
               } \
            } \
         } \
         free(szPath2); \
      } \
   } \
   ::SetLastError(dwErrCode)

#define BEGIN_REG_PARSE_PATH_GET(   bValidParam) BEGIN_REG_PARSE_PATH_EX(szKeyName,  TRUE, bValidParam, FALSE, 0)
#define BEGIN_REG_PARSE_PATH_SET(   bValidParam) BEGIN_REG_PARSE_PATH_EX(szKeyName,  TRUE, bValidParam,  TRUE, 0)
#define BEGIN_REG_PARSE_PATH_ENUM(  bValidParam) BEGIN_REG_PARSE_PATH_EX(szKey    , FALSE, bValidParam, FALSE, 0)
#define BEGIN_REG_PARSE_PATH_DELKEY(bValidParam) BEGIN_REG_PARSE_PATH_ENUM(bValidParam)
#define BEGIN_REG_PARSE_PATH_DELVAL              BEGIN_REG_PARSE_PATH_EX(szKeyName,  TRUE,        TRUE, FALSE, KEY_SET_VALUE)

#define BEGIN_REG_GET_DATA(needRegType) \
   DWORD cbMaxValue = 0; \
   DWORD dwErrCode = ::RegQueryInfoKey(hKey, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &cbMaxValue, NULL, NULL); \
   if (dwErrCode == ERROR_SUCCESS) { \
      BYTE *pbData = new BYTE[cbMaxValue]; \
      if (!pbData) { \
         dwErrCode = ERROR_OUTOFMEMORY; \
      } else { \
         DWORD dwType = REG_NONE, cbData=cbMaxValue; \
         dwErrCode = ::RegQueryValueEx(hKey, szValueName, NULL, &dwType, pbData, &cbData); \
         if (dwErrCode == ERROR_SUCCESS) { \
            if (dwType == needRegType) {

   #define END_REG_GET_DATA \
            } else { \
               dwErrCode = ERROR_DATATYPE_MISMATCH; \
            } \
         } \
      } \
      delete [] pbData; \
   } \
   ::SetLastError(dwErrCode)

#define BEGIN_REG_ENUM_SUBKEY(bEnumAllSubKeys) \
   DWORD cSubKeys = 0, cchMaxSubKey = 0; \
   DWORD dwErrCode = ::RegQueryInfoKey(hKey, NULL, NULL, NULL, &cSubKeys, &cchMaxSubKey, NULL, NULL, NULL, NULL, NULL, NULL); \
   if ((dwErrCode == ERROR_SUCCESS) && (cSubKeys==0)) { \
      dwErrCode = ERROR_NO_MORE_ITEMS; \
   } \
   if ((dwErrCode == ERROR_SUCCESS) /*&& cSubKeys*/) { \
      TCHAR *szSubKey = new TCHAR[cchMaxSubKey+1]; \
      if (!szSubKey) { \
         dwErrCode = ERROR_OUTOFMEMORY; \
      } else { \
         for (dwIndex=(bEnumAllSubKeys?0:dwIndex); bEnumAllSubKeys ? (dwIndex<cSubKeys) : true; dwIndex++) { \
            BOOL bEnumAll = bEnumAllSubKeys; \
            DWORD cchSubKey = cchMaxSubKey+1; \
            PFILETIME pFileTime = NULL; \
            dwErrCode = ::RegEnumKeyEx(hKey, dwIndex, szSubKey, &cchSubKey, NULL, NULL, NULL, pFileTime); \
            if (dwErrCode == ERROR_SUCCESS) {

#define END_REG_ENUM_SUBKEY \
            } else { \
               break; \
            } \
            if (!bEnumAll) break; \
         } \
         delete [] szSubKey; \
      } \
   } \
   ::SetLastError(dwErrCode)

#define BEGIN_REG_ENUM_VALUENAME(bEnumAllValueNames) \
   DWORD cValues = 0, cchMaxValueName = 0; \
   DWORD dwErrCode = ::RegQueryInfoKey(hKey, NULL, NULL, NULL, NULL, NULL, NULL, &cValues, &cchMaxValueName, NULL, NULL, NULL); \
   if ((dwErrCode == ERROR_SUCCESS) && (cValues==0)) { \
      dwErrCode = ERROR_NO_MORE_ITEMS; \
   } \
   if ((dwErrCode == ERROR_SUCCESS) /*&& cValues*/) { \
      TCHAR *szValueName = new TCHAR[cchMaxValueName+1]; \
      if (!szValueName) { \
         dwErrCode = ERROR_OUTOFMEMORY; \
      } else { \
         for (dwIndex=(bEnumAllValueNames?0:dwIndex); bEnumAllValueNames ? (dwIndex<cValues) : true; dwIndex++) { \
            BOOL bEnumAll = bEnumAllValueNames; \
            DWORD cchValueName = cchMaxValueName+1; \
            dwErrCode = ::RegEnumValue(hKey, dwIndex, szValueName, &cchValueName, NULL, &dwType, NULL, NULL); \
            if (dwErrCode == ERROR_SUCCESS) {

#define END_REG_ENUM_VALUENAME \
            } else { \
               break; \
            } \
            if (!bEnumAll) break; \
         } \
         delete [] szValueName; \
      } \
   } \
   ::SetLastError(dwErrCode)

//      
/* static */ CString CRegistry::GetString(IN HKEY hKey, IN LPCTSTR szValueName) {
   CString strResult;
   BEGIN_REG_GET_DATA(REG_SZ);
   strResult = (LPCTSTR)pbData;
   END_REG_GET_DATA;
   return strResult;
}

//      
/* static */ DWORD CRegistry::GetDWord(IN HKEY hKey, IN LPCTSTR szValueName) {
   DWORD dwResult = 0;
   BEGIN_REG_GET_DATA(REG_DWORD);
   dwResult = *((DWORD*)pbData);
   END_REG_GET_DATA;
   return dwResult;
}

//      
/* static */ DWORD CRegistry::GetBinary(IN HKEY hKey, IN LPCTSTR szValueName, OUT BYTE *pbValue, IN OUT DWORD &cbValue) {
   BEGIN_REG_GET_DATA(REG_BINARY);
   if (pbValue && (cbValue >= cbData)) {
      cbValue  = cbData;
      memcpy(pbValue, pbData, cbValue);
   } else {
      cbValue = cbData; //    
      dwErrCode = ERROR_INSUFFICIENT_BUFFER;
   }
   END_REG_GET_DATA;
   return dwErrCode;
}

//      
/* static */ DWORD CRegistry::SetString(IN HKEY hKey, IN LPCTSTR szValueName, IN LPCTSTR szValue) {
   DWORD dwErrCode = ::RegSetValueEx(hKey, szValueName, 0, REG_SZ, (LPBYTE)szValue, (lstrlen(szValue)+1)<<(sizeof(TCHAR)-1));
   return ::SetLastError(dwErrCode), dwErrCode;
}

//      
/* static */ DWORD CRegistry::SetDWord(IN HKEY hKey, IN LPCTSTR szValueName, IN DWORD dwValue) {
   DWORD dwErrCode = ::RegSetValueEx(hKey, szValueName, 0, REG_DWORD, (LPBYTE)&dwValue, sizeof(DWORD));
   return ::SetLastError(dwErrCode), dwErrCode;
}

//      
/* static */ DWORD CRegistry::SetBinary(IN HKEY hKey, IN LPCTSTR szValueName, IN const BYTE *pbValue, IN DWORD cbValue) {
   DWORD dwErrCode = (!pbValue || !cbValue) ? ERROR_INVALID_PARAMETER : ::RegSetValueEx(hKey, szValueName, 0, REG_BINARY, pbValue, cbValue);
   return ::SetLastError(dwErrCode), dwErrCode;
}

/* static */ CString CRegistry::GetString(IN LPCTSTR szKeyName) {
   CString strResult;
   BEGIN_REG_PARSE_PATH_GET(TRUE);
   strResult = CRegistry::GetString(hKey, szValueName);
   END_REG_PARSE_PATH;
   return strResult;
}

/* static */ DWORD CRegistry::GetDWord(IN LPCTSTR szKeyName) {
   DWORD dwResult = 0;
   BEGIN_REG_PARSE_PATH_GET(TRUE);
   dwResult = CRegistry::GetDWord(hKey, szValueName);
   END_REG_PARSE_PATH;
   return dwResult;
}

/* static */ DWORD CRegistry::GetBinary(IN LPCTSTR szKeyName, OUT BYTE *pbValue, IN OUT DWORD &cbValue) {
   BEGIN_REG_PARSE_PATH_GET(pbValue && cbValue);
   dwErrCode = CRegistry::GetBinary(hKey, szValueName, pbValue, cbValue);
   END_REG_PARSE_PATH;
   return dwErrCode;
}

/* static */ DWORD CRegistry::SetString(IN LPCTSTR szKeyName, IN LPCTSTR szValue) {
   BEGIN_REG_PARSE_PATH_SET(szValue);
   dwErrCode = CRegistry::SetString(hKey, szValueName, szValue);
   END_REG_PARSE_PATH;
   return dwErrCode;
}

/* static */ DWORD CRegistry::SetDWord(IN LPCTSTR szKeyName, IN DWORD dwValue) {
   BEGIN_REG_PARSE_PATH_SET(TRUE);
   dwErrCode = CRegistry::SetDWord(hKey, szValueName, dwValue);
   END_REG_PARSE_PATH;
   return dwErrCode;
}

/* static */ DWORD CRegistry::SetBinary(IN LPCTSTR szKeyName, IN const BYTE *pbValue, IN DWORD cbValue) {
   BEGIN_REG_PARSE_PATH_SET(pbValue && cbValue);
   dwErrCode = CRegistry::SetBinary(hKey, szValueName, pbValue, cbValue);
   END_REG_PARSE_PATH;
   return dwErrCode;
}

// find methods
namespace nsRegistry {
   BOOL EnumSubKeyName(IN HKEY hKey, IN LPCTSTR szKey, IN CRegistry::SUBKEYENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
      BOOL bRes = FALSE;
      DWORD dwIndex = 0;
      BEGIN_REG_ENUM_SUBKEY(true);
      bRes = lpEnumFunc(hKey, szKey, dwIndex, szSubKey, lpUserData);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         break;
      }
      END_REG_ENUM_SUBKEY;
      bRes = (dwErrCode == ERROR_SUCCESS) ||
             ((dwErrCode == ERROR_NO_MORE_ITEMS) && (cSubKeys == 0)); //  
      return bRes;
   }

   BOOL EnumValueName(IN HKEY hKey, IN LPCTSTR szKey, IN CRegistry::VALUENAMEENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
      BOOL bRes = FALSE;
      DWORD dwIndex = 0;
      DWORD dwType = REG_NONE;
      BEGIN_REG_ENUM_VALUENAME(true);
      bRes = lpEnumFunc(hKey, szKey, dwIndex, szValueName, dwType, lpUserData);
      if (!bRes) {
         dwErrCode = ::GetLastError();
         break;
      }
      END_REG_ENUM_VALUENAME;
      bRes = (dwErrCode == ERROR_SUCCESS) ||
             ((dwErrCode == ERROR_NO_MORE_ITEMS) && (cValues == 0)); //  
      return bRes;
   }
} // namespace nsRegistry

/* static */ CString CRegistry::EnumSubKeyName(IN HKEY hKey, IN DWORD dwIndex) {
   CString strResult;
   BEGIN_REG_ENUM_SUBKEY(false);
   strResult = szSubKey;
   END_REG_ENUM_SUBKEY;
   return strResult;
}

/* static */ CString CRegistry::EnumSubKeyName(IN LPCTSTR szKey, IN DWORD dwIndex) {
   CString strResult;
   BEGIN_REG_PARSE_PATH_ENUM(TRUE);
   strResult = CRegistry::EnumSubKeyName(hKey, dwIndex);
   END_REG_PARSE_PATH;
   return strResult;
}

/* static */ BOOL CRegistry::EnumSubKeyName(IN HKEY hKey, IN SUBKEYENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
   return nsRegistry::EnumSubKeyName(hKey, NULL, lpEnumFunc, lpUserData);
}

/* static */ BOOL CRegistry::EnumSubKeyName(IN LPCTSTR szKey, IN SUBKEYENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
   BOOL bRes = FALSE;
   BEGIN_REG_PARSE_PATH_ENUM(lpEnumFunc);
   bRes = nsRegistry::EnumSubKeyName(hKey, szKey, lpEnumFunc, lpUserData);
   END_REG_PARSE_PATH;
   return bRes;
}

/* static */ CString CRegistry::EnumValueName(IN HKEY hKey, IN DWORD dwIndex, OUT DWORD &dwType) {
   CString strResult;
   BEGIN_REG_ENUM_VALUENAME(false);
   strResult = szValueName;
   END_REG_ENUM_VALUENAME;
   return strResult;
}

/* static */ CString CRegistry::EnumValueName(IN LPCTSTR szKey, IN DWORD dwIndex, OUT DWORD &dwType) {
   CString strResult;
   BEGIN_REG_PARSE_PATH_ENUM(TRUE);
   strResult = CRegistry::EnumValueName(hKey, dwIndex, dwType);
   END_REG_PARSE_PATH;
   return strResult;
}

/* static */ BOOL CRegistry::EnumValueName(IN HKEY hKey, IN VALUENAMEENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
   return nsRegistry::EnumValueName(hKey, NULL, lpEnumFunc, lpUserData);
}

/* static */ BOOL CRegistry::EnumValueName(IN LPCTSTR szKey, IN VALUENAMEENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
   BOOL bRes = FALSE;
   BEGIN_REG_PARSE_PATH_ENUM(lpEnumFunc);
   bRes = nsRegistry::EnumValueName(hKey, szKey, lpEnumFunc, lpUserData);
   END_REG_PARSE_PATH;
   return bRes;
}

/* static */ BOOL CRegistry::DeleteKey(IN HKEY hKey, IN LPCTSTR szSubKey) {
   DWORD dwErrCode = ::RegDeleteKey(hKey, szSubKey);             
   ::SetLastError(dwErrCode);
   return (dwErrCode == ERROR_SUCCESS);
}

/* static */ BOOL CRegistry::DeleteKey(IN LPCTSTR szKey, IN LPCTSTR szSubKeyIn) {
   BOOL bRes = FALSE;
   BEGIN_REG_PARSE_PATH_DELKEY(szSubKeyIn);
   bRes = CRegistry::DeleteKey(hKey, szSubKeyIn);
   END_REG_PARSE_PATH;
   return bRes;
}

/* static */ BOOL CRegistry::DeleteValue(IN HKEY hKey, IN LPCTSTR szValueName) {
   DWORD dwErrCode = ::RegDeleteValue(hKey, szValueName);
   ::SetLastError(dwErrCode);
   return (dwErrCode == ERROR_SUCCESS);
}

/* static */ BOOL CRegistry::DeleteValue(IN LPCTSTR szKeyName) {
   BOOL bRes = FALSE;
   BEGIN_REG_PARSE_PATH_DELVAL;
   bRes = CRegistry::DeleteValue(hKey, szValueName);
   END_REG_PARSE_PATH;
   return bRes;
}

////////////////////////////////////////////////////////////////////////////////
//    end class CRegistry
////////////////////////////////////////////////////////////////////////////////

//     
LPCVOID GetResource(
   IN HMODULE hMod,
   IN LPCTSTR szResourceType,
   IN LPCTSTR szResourceName,
   OUT DWORD &dwSize
) {
   ::SetLastError(NO_ERROR);
   dwSize = 0;
   LPVOID pRes = NULL;
   HRSRC hRsrc = ::FindResource(hMod, szResourceName, szResourceType);
   if (hRsrc) {
      HGLOBAL hGlobal = ::LoadResource(hMod, hRsrc);
      if (hGlobal) {
         dwSize = ::SizeofResource(hMod, hRsrc);
         if (dwSize) {
            pRes = ::LockResource(hGlobal);
            if (!pRes)
               dwSize = 0;
         }
      }
   }
   return pRes;
}

//     
LPCVOID GetResource(
   IN HMODULE hMod,
   IN LPCTSTR szResourceType,
   IN LPCTSTR szResourceName,
   IN WORD wLanguage,
   OUT DWORD &dwSize
) {
   ::SetLastError(NO_ERROR);
   dwSize = 0;
   LPVOID pRes = NULL;
   HRSRC hRsrc = ::FindResourceEx(hMod, szResourceType, szResourceName, wLanguage);
   if (hRsrc) {
      HGLOBAL hGlobal = ::LoadResource(hMod, hRsrc);
      if (hGlobal) {
         dwSize = ::SizeofResource(hMod, hRsrc);
         if (dwSize) {
            pRes = ::LockResource(hGlobal);
            if (!pRes)
               dwSize = 0;
         }
      }
   }
   return pRes;
}

BOOL SaveResourceAsFile_internal(
   IN const BYTE *pResource,
   IN DWORD       nbSize,
   IN HMODULE     hMod,
   IN LPCTSTR     szFileName,
   IN LPCTSTR     szResourceType,
   IN LPCTSTR     szResourceName,
   IN BOOL        bReplaceFile
) {
   DWORD dwErrCode = NO_ERROR;
   BOOL bRes = ((pResource != NULL) && (nbSize!=0));
   if (!bRes) {
      dwErrCode = ERROR_INVALID_PARAMETER;
   } else {
      if (!::FileExist(szFileName)) {
         bReplaceFile = TRUE;
      }
      if (bReplaceFile) {
         switch ((ULONG_PTR)szResourceType) {
         case RT_GROUP_ICON:
         #ifdef __FILE__ICONS__
            bRes = ::ExtractIco(hMod, (WORD)szResourceName, szFileName);
            if (!bRes) {
               dwErrCode = ::GetLastError();
            }
         #else // __FILE__ICONS__
            bRes = FALSE;
            #pragma message("  >>>Please include 'Icon.h' to the project - add header to this file (" __FILE__ ") or 'StdAfx.h' file...")
            dwErrCode = ERROR_CALL_NOT_IMPLEMENTED;
         #endif // __FILE__ICONS__
            break;
         case RT_ICON:
            bRes = IS_INTRESOURCE(szResourceName);
            if (!bRes) {
               // resouce name   WORD'
               dwErrCode = ERROR_INVALID_PARAMETER;
            } else {
         #ifdef __FILE__ICONS__
               bRes = ::ExtractIco(hMod, (WORD)szResourceName, szFileName);
               if (!bRes) {
                  dwErrCode = ::GetLastError();
               }
         #else // __FILE__ICONS__
               bRes = FALSE;
               #pragma message("  >>>Please include 'Icon.h' to the project - add header to this file (" __FILE__ ") or 'StdAfx.h' file...")
               dwErrCode = ERROR_CALL_NOT_IMPLEMENTED;
         #endif // __FILE__ICONS__
            }
            break;
         default:
            {
               HANDLE hFile = ::CreateFile(
                  szFileName,
                  GENERIC_WRITE,
                  FILE_SHARE_READ,
                  NULL,
                  CREATE_ALWAYS,
                  FILE_ATTRIBUTE_NORMAL,
                  NULL
               );
               bRes = (hFile != INVALID_HANDLE_VALUE);
               if (!bRes) {
                  dwErrCode = ::GetLastError();
               } else {
                  DWORD dwNOBW = 0;
                  switch ((ULONG_PTR)szResourceType) {
                  case RT_BITMAP:
                     if ((*((DWORD*)pResource)) != sizeof(BITMAPINFOHEADER)) {
                        dwErrCode = ERROR_INVALID_DATA; //   -     BMP
                        bRes = FALSE;
                     } else {
                        BITMAPINFOHEADER *pBmpIH = (BITMAPINFOHEADER*)pResource;
                        DWORD dwOffsetToBitmapBits = 0;
                        //switch (pBmpIH->biClrUsed) {
                        //case 0:
                           switch (pBmpIH->biBitCount) {
                           case 1: dwOffsetToBitmapBits = sizeof(RGBQUAD)<<1; break;
                           case 4: dwOffsetToBitmapBits = sizeof(RGBQUAD)<<4; break;
                           case 8: dwOffsetToBitmapBits = sizeof(RGBQUAD)<<8; break;
                           default: break; //   -     BMP
                           }
                        //   break;
                        //default:
                        //   break; //   -     BMP
                        //}

                        BITMAPFILEHEADER bmpFH = {
                           0x4D42,                                                                 // WORD    bfType;
                           nbSize+sizeof(BITMAPFILEHEADER),                                        // DWORD   bfSize;
                           0,0,                                                                    // WORD    bfReserved1;WORD    bfReserved2;
                           sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+dwOffsetToBitmapBits  // DWORD   bfOffBits;
                        };
                        bRes = (::WriteFile(hFile, &bmpFH, sizeof(BITMAPFILEHEADER), &dwNOBW, NULL) && (sizeof(BITMAPFILEHEADER) == dwNOBW));
                        if (!bRes) {
                           dwErrCode = ::GetLastError();
                        }
                     }
                     //  break'a  bitmap'!!!
                  default:
                     if (bRes) {
                        bRes = (::WriteFile(hFile, pResource, nbSize, &dwNOBW, NULL) && (nbSize == dwNOBW));
                        if (!bRes) {
                           dwErrCode = ::GetLastError();
                        }
                     }
                  }
                  ::CloseHandle(hFile); hFile = NULL;
               }
            }
         }
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}


BOOL SaveResourceAsFile(
   IN HMODULE hMod,
   IN LPCTSTR szFileName,
   IN LPCTSTR szResourceType,
   IN LPCTSTR szResourceName,
   IN BOOL    bReplaceFile
) {
   BOOL bRes = FALSE;
   DWORD dwSize = 0;
   const BYTE *pResource = (const BYTE*)GetResource(hMod, szResourceType, szResourceName, dwSize);
   DWORD dwErrCode = ::GetLastError();
   if (pResource && (dwErrCode == ERROR_SUCCESS)) {
      bRes = SaveResourceAsFile_internal(pResource, dwSize, hMod, szFileName, szResourceType, szResourceName, bReplaceFile);
      if (!bRes) {
         dwErrCode = ::GetLastError();
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}


BOOL SaveResourceAsFile(
   IN HMODULE hMod,
   IN LPCTSTR szFileName,
   IN LPCTSTR szResourceType,
   IN LPCTSTR szResourceName,
   IN WORD    wLanguage,
   IN BOOL    bReplaceFile
) {
   BOOL bRes = FALSE;
   DWORD dwSize = 0;
   const BYTE *pResource = (const BYTE*)GetResource(hMod, szResourceType, szResourceName, wLanguage, dwSize);
   DWORD dwErrCode = ::GetLastError();
   if (pResource && (dwErrCode == ERROR_SUCCESS)) {
      bRes = SaveResourceAsFile_internal(pResource, dwSize, hMod, szFileName, szResourceType, szResourceName, bReplaceFile);
      if (!bRes) {
         dwErrCode = ::GetLastError();
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}


BOOL String2GUID(IN LPCTSTR szGUID, OUT GUID &guid) {
   BOOL bRes = FALSE;
   DWORD dwErrCode = ERROR_INVALID_PARAMETER;
   if (szGUID) {
      USES_CONVERSION;
      HRESULT hRes = ::CLSIDFromString(T2OLE(const_cast<TCHAR*>(szGUID)), &guid);
      switch (hRes) {
      case NOERROR           : bRes = TRUE ; dwErrCode = ERROR_SUCCESS;    break;
      case CO_E_CLASSSTRING  : bRes = FALSE; dwErrCode = ERROR_BAD_FORMAT; break; // The class string was improperly formatted.
      case REGDB_E_WRITEREGDB: // The CLSID corresponding to the class string was not found in the registry.
      default:
         if (szGUID) {
            dwErrCode = ERROR_INVALID_DATA;
            //    GUID
            // 0         1         2         3
            // 01234567890123456789012345678901234567
            // {01234567-0123-0123-0123-0123456789AB}
            CString strGUID(szGUID);
            strGUID.MakeUpper();
            static TCHAR szABC[] = _T("0123456789ABCDEF");
            if ((strGUID.GetLength() != 38) ||
                (szGUID[ 0] != _T('{')) ||
                (szGUID[ 9] != _T('-')) ||
                (szGUID[14] != _T('-')) ||
                (szGUID[19] != _T('-')) ||
                (szGUID[24] != _T('-')) ||
                (szGUID[37] != _T('}')) /**/||
                (!strGUID.Mid( 1, 8).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(10, 4).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(15, 4).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(20, 4).SpanExcluding(szABC).IsEmpty()) ||
                (!strGUID.Mid(25,12).SpanExcluding(szABC).IsEmpty())/**/
               )
            {
            } else {
               strGUID.Replace(_T('{'), _T(' '));
               strGUID.Replace(_T('-'), _T(' '));
               strGUID.Replace(_T('}'), _T(' '));
               /**
               strGUID = strGUID.Mid( 1, 8) + //
                         strGUID.Mid(10, 4) + // + _T(" ")
                         strGUID.Mid(15, 4) + // + _T(" ")
                         strGUID.Mid(20, 2) + // + _T(" ")
                         strGUID.Mid(22, 2) + // + _T(" ")
                         strGUID.Mid(25, 2) + // + _T(" ")
                         strGUID.Mid(27, 2) + // + _T(" ")
                         strGUID.Mid(29, 2) + // + _T(" ")
                         strGUID.Mid(31, 2) + // + _T(" ")
                         strGUID.Mid(33, 2) + // + _T(" ")
                         strGUID.Mid(35, 2);  // + _T(" ")
               /**/
               int iData1=0, iData2=0, iData3=0, iData4[8] = {0,0,0,0,0,0,0,0};
               if (
         #ifdef _stscanf_s
                  _stscanf_s
         #else
                  _stscanf
         #endif
                   ((LPCTSTR)strGUID, _T("%08X%04X%04X%02X%02X%02X%02X%02X%02X%02X%02X"),
                     &iData1, &iData2, &iData3,
                     &iData4[0], &iData4[1], &iData4[2], &iData4[3],
                     &iData4[4], &iData4[5], &iData4[6], &iData4[7]) == 11)
               {
                  guid.Data1 = iData1; guid.Data2 = iData2; guid.Data3 = iData3;
                  guid.Data4[0] = iData4[0];
                  guid.Data4[1] = iData4[1];
                  guid.Data4[2] = iData4[2];
                  guid.Data4[3] = iData4[3];
                  guid.Data4[4] = iData4[4];
                  guid.Data4[5] = iData4[5];
                  guid.Data4[6] = iData4[6];
                  guid.Data4[7] = iData4[7];
                  bRes = TRUE;
                  dwErrCode = ERROR_SUCCESS;
               } else {
                  dwErrCode = ERROR_INVALID_DATA; //::GetLastError();
               }
            }
         }
      } // swicth
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

CString ErrorCode2Str(DWORD dwErrCode) {
   CString strRes;
   LPTSTR lpMsgBuf = NULL;
   DWORD dwRes = ::FormatMessage(
      FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
      NULL,
      dwErrCode,
      MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
      (LPTSTR)&lpMsgBuf,
      0,
      NULL
   );
   if (dwRes != 0) {
      strRes = lpMsgBuf;
      strRes.Replace(_T("\r\n"), _T(" "));
      strRes.TrimRight();
   } else {
      //DWORD dwErrCode2 = ::GetLastError(); // must be ERROR_MR_MID_NOT_FOUND ???
   }
   ::LocalFree(lpMsgBuf);
   if (strRes.IsEmpty()) {
      if (dwErrCode & 0x80000000) {
         strRes.Format(_T("Unknown error 0x%08X"), dwErrCode);
      } else {
         strRes.Format(_T("Unknown error %i"), dwErrCode);
      }
   }
   return strRes;
}

CString ErrorCode2Str(IN HMODULE hModule, IN DWORD dwErrCode) {
   DWORD dwErrCodeRes = ERROR_SUCCESS;
   LPTSTR szError = NULL;
   DWORD dwBaseLength = ::FormatMessage(
      FORMAT_MESSAGE_IGNORE_INSERTS |
      FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_HMODULE, // dwFlags
      hModule,                                                      // lpSource
      dwErrCode,                                                    // dwMessageId
      0,                                                            // dwLanguageId
      (LPTSTR)&szError,                                             // lpBuffer
      0,                                                            // nSize
      NULL );                                                       // * arguments

   CString strRes;
   if (dwBaseLength == 0) {
      dwErrCodeRes = ::GetLastError();
   } else {
      strRes = szError;
      strRes.Replace(_T("\r\n"), _T(" "));
      strRes.TrimRight();
   }
   if (szError) {
      ::LocalFree(szError);
   }
   ::SetLastError(dwErrCodeRes);
   return strRes;
}

CString ErrorCode2Str(IN LPCTSTR lpModuleName, IN DWORD dwErrCode) {
   DWORD dwErrCodeRes = ERROR_SUCCESS;
   HMODULE hMod = ::GetModuleHandle(lpModuleName);
   BOOL bLoadLibrary = FALSE;
   if (hMod == NULL) {
      hMod = ::LoadLibrary(lpModuleName);
      bLoadLibrary = (hMod != NULL);
      if (!bLoadLibrary) {
         dwErrCodeRes = ::GetLastError();
      }
   }

   CString strRes;
   if (hMod) {
      strRes = ErrorCode2Str(hMod, dwErrCode);
      if (strRes.IsEmpty()) {
         dwErrCodeRes = ::GetLastError();
      }
   }

   if (bLoadLibrary) {
      BOOL bRes = ::FreeLibrary(hMod);
   }
   ::SetLastError(dwErrCodeRes);
   return strRes;
}

CString WinInetErrorCode2Str(DWORD dwErrCode) {
   DWORD dwErrCodeRes = ERROR_SUCCESS;
   CString strRes = ErrorCode2Str(_T("WinInet.dll"), dwErrCode);
   if (strRes.IsEmpty()) {
      dwErrCodeRes = ::GetLastError();
   } else {
      strRes = _T("Internet API error. ") + strRes;

      if (dwErrCode == ERROR_INTERNET_EXTENDED_ERROR) {
         DWORD dwInetError = 0;
         DWORD dwExtLength = 0;
         BOOL bRes = nsWinInet_API::InternetGetLastResponseInfo(&dwInetError, NULL, &dwExtLength);
         DWORD dwErrCode2 = ::GetLastError();
         if ((dwErrCode2 != ERROR_INSUFFICIENT_BUFFER) || (dwExtLength==0)) {
            dwErrCodeRes = ::GetLastError();
         } else {
            TCHAR *szExtErrMsg = new TCHAR [dwExtLength = dwExtLength+1]; // + EOL
            if (szExtErrMsg == NULL) {
               dwErrCodeRes = ERROR_OUTOFMEMORY;
            } else {
               szExtErrMsg[0] = 0;
               BOOL bRes = nsWinInet_API::InternetGetLastResponseInfo(&dwInetError, szExtErrMsg, &dwExtLength);
               if (!bRes) {
                  dwErrCodeRes = ::GetLastError();
               } else {
                  strRes += szExtErrMsg;
               }

               delete [] szExtErrMsg;
            }
         }
      }
   }
   ::SetLastError(dwErrCodeRes);
   return strRes;
}

BOOL EnumFiles(IN LPCTSTR szDirName, IN LPCTSTR szMask, IN FILEENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
   if (!szDirName || !szDirName[0] || /*!szMask || !szMask[0] || */!lpEnumFunc) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
      return FALSE;
   }
   WIN32_FIND_DATA findFileData;
   HANDLE hFindFile = NULL;
   BOOL bRes = TRUE;
   DWORD dwErrCode = NO_ERROR;
   CString strDirName(szDirName);
   if (strDirName[strDirName.GetLength()-1] != _T('\\')) {
      strDirName += _T('\\');
   }
   UINT iPos = 0;
   do {
      if (hFindFile == NULL) {
         hFindFile = ::FindFirstFile(strDirName + ((szMask && szMask[0]) ? szMask : _T("*")), &findFileData);
         bRes = (hFindFile != INVALID_HANDLE_VALUE);
      } else {
         bRes = ::FindNextFile(hFindFile, &findFileData);
      }
      if (!bRes) {
         dwErrCode = ::GetLastError();
         if (hFindFile == INVALID_HANDLE_VALUE) {
            if ((dwErrCode == ERROR_FILE_NOT_FOUND) ||
                (dwErrCode == ERROR_PATH_NOT_FOUND))
            {
               bRes = TRUE;
            }
         } else {
            if (dwErrCode == ERROR_NO_MORE_FILES) {
               bRes = TRUE;
            }
         }
         break;
      } else {
         if (!(findFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
            bRes &= lpEnumFunc(szDirName, findFileData.cFileName, iPos++, lpUserData);
         }
      }
   } while(bRes);
   if (hFindFile != INVALID_HANDLE_VALUE) {
      bRes = ::FindClose(hFindFile); hFindFile = NULL;
      if (!bRes) {
         dwErrCode = ::GetLastError();
         if (dwErrCode == ERROR_NO_MORE_FILES) {
            bRes = TRUE;
         }
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}

BOOL EnumSubDir(IN LPCTSTR szDirName, IN DIRENUMPROC lpEnumFunc, IN LPVOID lpUserData) {
   if (!szDirName || !szDirName[0] || !lpEnumFunc) {
      ::SetLastError(ERROR_INVALID_PARAMETER);
      return FALSE;
   }
   WIN32_FIND_DATA findFileData;
   HANDLE hFindFile = NULL;
   BOOL bRes = TRUE;
   DWORD dwErrCode = NO_ERROR;
   CString strDirName(szDirName);
   if (strDirName[strDirName.GetLength()-1] != _T('\\')) {
      strDirName += _T('\\');
   }
   UINT iPos = 0;
   do {
      if (hFindFile == NULL) {
#if(_WIN32_WINNT >= 0x0400)
         hFindFile = ::FindFirstFileEx(strDirName + _T('*'), FindExInfoStandard, &findFileData, FindExSearchLimitToDirectories, NULL, 0);
         if (hFindFile == INVALID_HANDLE_VALUE)
#endif // (_WIN32_WINNT >= 0x0400)
         {
            hFindFile = ::FindFirstFile(strDirName + _T('*'), &findFileData);
         }
         bRes = (hFindFile != INVALID_HANDLE_VALUE);
      } else {
         bRes = ::FindNextFile(hFindFile, &findFileData);
      }
      if (!bRes) {
         dwErrCode = ::GetLastError();
         if (hFindFile == INVALID_HANDLE_VALUE) {
            if ((dwErrCode == ERROR_FILE_NOT_FOUND) ||
                (dwErrCode == ERROR_PATH_NOT_FOUND))
            {
               bRes = TRUE;
            }
         } else {
            if (dwErrCode == ERROR_NO_MORE_FILES) {
               bRes = TRUE;
            }
         }
         break;
      } else {
         if (findFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
            if (findFileData.cFileName[0]==_T('.') && (findFileData.cFileName[1]==_T('\0') ||
                                                      (findFileData.cFileName[1]==_T('.') && findFileData.cFileName[2]==_T('\0'))))
            {} else
            //if (lstrcmp(findFileData.cFileName, _T(".")) &&
            //    lstrcmp(findFileData.cFileName, _T("..")))
            {
               bRes &= lpEnumFunc(szDirName, findFileData.cFileName, iPos++, lpUserData);
            }

         }
      }
   } while(bRes);
   if (hFindFile != INVALID_HANDLE_VALUE) {
      bRes = ::FindClose(hFindFile); hFindFile = NULL;
      if (!bRes) {
         dwErrCode = ::GetLastError();
         if (dwErrCode == ERROR_NO_MORE_FILES) {
            bRes = TRUE;
         }
      }
   }
   ::SetLastError(dwErrCode);
   return bRes;
}
