// MsgTblViewDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MsgTblView.h"
#include "MsgTblViewDlg.h"
#include <Set>
#pragma comment(lib, "Msimg32")

#define ID_SUBITEM_MODULE_NAME 0
#define ID_SUBITEM_PATH        1
#define ID_SUBITEM_ERR         2
#define ID_SUBITEM_LANG        3
#define ID_SUBITEM_MSG_VAL     4
#define ID_SUBITEM_MSG_HEX     5
#define ID_SUBITEM_MSG_TEXT    6

#define ID_TIMER_FIRST_SCAN 123

#define PROJ_CAPTION_TEXT _T("Message Table viewer")

#ifdef _DEBUG
   #define new DEBUG_NEW
   #undef THIS_FILE
   static char THIS_FILE[] = __FILE__;
#endif

struct CUserDataParam {
   CMsgTblFindedDlg *m_pMsgTblFindedDlg;
   CString           m_strModuleName;
   CString           m_strPath;
   CReportJob        m_Report;
   CUserDataParam(CMsgTblFindedDlg *pMsgTblFindedDlg, LPCTSTR szModuleName, LPCTSTR szPath) : 
      m_pMsgTblFindedDlg(pMsgTblFindedDlg),
      m_strModuleName   (szModuleName),
      m_strPath         (szPath) {}
};

struct CUserDataParam2 {
   CMsgTblViewDlg *m_pMsgTblViewDlg;
   CReportJob     &m_Report;
   CUserDataParam2(CMsgTblViewDlg *pMsgTblViewDlg, CReportJob &Report) : m_pMsgTblViewDlg(pMsgTblViewDlg), m_Report(Report) {}
};

inline SIZE SizeIcon(HICON hIcon) {
   SIZE resSize = {0,0};
   ICONINFO iconInfo;
   if (::GetIconInfo(hIcon, &iconInfo)) {
      resSize.cx = iconInfo.xHotspot<<1;
      resSize.cy = iconInfo.yHotspot<<1;
   }
   return resSize;
}

BOOL CALLBACK EnumLangsFunc_MessageTable( 
   HMODULE  hModule,  // module handle 
   LPCTSTR  lpszType, // address of resource type 
   LPCTSTR  lpszName, // address of resource name 
   WORD     wLang,    // resource language 
   LONG_PTR lParam)   // extra parameter, could be used for error checking 
{ 
   CUserDataParam *pUserData = (CUserDataParam*)lParam;
   if (pUserData == NULL) {
      //DWORD dwErrCode = ERROR_INVALID_USER_BUFFER;
      LOG_PUT(g_pLog, Put, LL_FATAL) _T("  EnumLangsFunc_MessageTable: User data invalid "));
      return FALSE;
   }

   if (lpszType == MAKEINTRESOURCE(RT_MESSAGETABLE)) {
      HRSRC hRsrc = ::FindResourceEx(hModule, lpszType, lpszName, wLang);
      if (!hRsrc) {
         DWORD dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumLangsFunc_MessageTable: FindResourceEx(module [%s]) "), (LPCTSTR)pUserData->m_strModuleName), dwErrCode);
      } else {
         HGLOBAL hGlobal = ::LoadResource(hModule, hRsrc);
         if (!hGlobal) {
            DWORD dwErrCode = ::GetLastError();
            LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumLangsFunc_MessageTable: LoadResource(module [%s]) "), (LPCTSTR)pUserData->m_strModuleName), dwErrCode);
         } else {
            DWORD dwSize = ::SizeofResource(hModule, hRsrc);
            LPVOID pRes = ::LockResource(hGlobal);
            if (!pRes) {
               DWORD dwErrCode = ::GetLastError();
               LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumLangsFunc_MessageTable: LockResource(module [%s]) "), (LPCTSTR)pUserData->m_strModuleName), dwErrCode);
            } else {
               int iIndex = pUserData->m_pMsgTblFindedDlg->m_ctrlListMsgTable.GetItemCount(); //    ,   !

               // 1.            ListControl'e
               int iCount = 0;
               MESSAGE_RESOURCE_DATA *pRD = (MESSAGE_RESOURCE_DATA*)pRes;
               DWORD i=0;
               for (; i<pRD->NumberOfBlocks; i++) {
                  MESSAGE_RESOURCE_BLOCK &Block = pRD->Blocks[i];
                  iCount += Block.HighId-Block.LowId+1;
               }
               pUserData->m_pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemCount(pUserData->m_pMsgTblFindedDlg->m_ctrlListMsgTable.GetItemCount()+iCount);

               pUserData->m_Report.m_iCountFilesOk++;
               pUserData->m_Report.m_iCountMessages += iCount;

               // 2.  ListControl
               pRD = (MESSAGE_RESOURCE_DATA*)pRes;
               for (i=0; i<pRD->NumberOfBlocks; i++) {
                  MESSAGE_RESOURCE_BLOCK &Block = pRD->Blocks[i];
                  ULONG ulOffsetToEntries = Block.OffsetToEntries;
                  for (ULONG j=Block.LowId; j<=Block.HighId; j++) {
                     MESSAGE_RESOURCE_ENTRY &Entry = *(MESSAGE_RESOURCE_ENTRY*)(((BYTE*)pRes)+ulOffsetToEntries);
                     CString strErrorMessage;
                     if (Entry.Flags) {
                        // Unicode
                        strErrorMessage = (LPCWSTR)Entry.Text;
                     } else {
                        // ANSI
                        strErrorMessage = (LPCSTR)Entry.Text;
                     }
                     strErrorMessage.Replace(_T("\r\n"), _T(" "));
                     strErrorMessage.TrimRight();

                     //LOG_PUT(g_pLog, Put, LL_DEBUG) _T("[%s] (Lang-%i) - Error: Id=0x%08X(%11i) - %s"), (LPCTSTR)pUserData->m_strModuleName, int(wLang), j, j, (LPCTSTR)strErrorMessage);
                     int iIndex2 = pUserData->m_pMsgTblFindedDlg->m_ctrlListMsgTable.InsertItem(iIndex, pUserData->m_strModuleName);
                     pUserData->m_pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex2, ID_SUBITEM_PATH    , pUserData->m_strPath);
                     pUserData->m_pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex2, ID_SUBITEM_LANG    , ::Format(_T("%d (%s)"), wLang, (LPCTSTR)::Locale(wLang, LOCALE_SNATIVELANGNAME)));
                     pUserData->m_pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex2, ID_SUBITEM_MSG_VAL , ::Format(_T("%d"), j));
                     pUserData->m_pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex2, ID_SUBITEM_MSG_HEX , ::Format(_T("0x%08X"), j));
                     pUserData->m_pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex2, ID_SUBITEM_MSG_TEXT, strErrorMessage);
                     iIndex++;

                     ulOffsetToEntries += Entry.Length;
                  }
               }
            }
         }
      }
      return TRUE; 
   }
   LOG_PUT(g_pLog, Put, LL_FATAL) _T("  EnumLangsFunc_MessageTable: Invalid resource type "));
   return FALSE;
}

BOOL CALLBACK EnumResNameProc_MessageTable(
   HMODULE  hModule,
   LPCTSTR  lpszType,
   LPTSTR   lpszName,
   LONG_PTR lParam
) {
   CUserDataParam *pUserData = (CUserDataParam*)lParam;
   if (pUserData == NULL) {
      //DWORD dwErrCode = ERROR_INVALID_USER_BUFFER;
      LOG_PUT(g_pLog, Put, LL_FATAL) _T("  EnumResNameProc_MessageTable: User data invalid "));
      return FALSE;
   }

   if (lpszType == MAKEINTRESOURCE(RT_MESSAGETABLE)) {
      /** /
      CString strNameFormat;
      if (IS_INTRESOURCE(lpszName)) {
         if (DWORD(lpszName) & 0x80000000) {
            strNameFormat = _T("0x%08X");
         } else {
            strNameFormat = _T("%i");
         }
      } else {
         strNameFormat = _T("%s");
      }

      LOG_PUT(g_pLog, Put, LL_DEBUG) _T("  EnumResNameProc_MessageTable: module %s: MessageTable name of a resource [")+strNameFormat+("] "), (LPCTSTR)pUserData->m_strModuleName, lpszName);
      /**/

      BOOL bRes = ::EnumResourceLanguages(hModule, lpszType, lpszName, EnumLangsFunc_MessageTable, lParam); 
      if (!bRes) {
         DWORD dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  EnumResNameProc_MessageTable: EnumResourceLanguages(module [%s]) "), (LPCTSTR)pUserData->m_strModuleName), dwErrCode);
      }
      return TRUE;
   }
   LOG_PUT(g_pLog, Put, LL_FATAL) _T("  EnumResNameProc_MessageTable: Invalid resource type "));
   return FALSE;
}

CReportJob MsgTblViewCodeInModule(IN CMsgTblFindedDlg *pMsgTblFindedDlg, IN const CString &strDirName, IN LPCTSTR lpModuleName) {
   CReportJob ReportJob;
   ReportJob.m_iCountFilesAll++;
   HMODULE hMod = ::LoadLibraryEx(strDirName+_T('\\')+lpModuleName, NULL, LOAD_LIBRARY_AS_DATAFILE);
   if (hMod == NULL) {
      DWORD dwErrCode = ::GetLastError();
      LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  MsgTblViewCodeInModule: LoadLibraryEx('%s'): "), lpModuleName), dwErrCode);

      int iIndex = pMsgTblFindedDlg->m_ctrlListMsgTable.InsertItem(pMsgTblFindedDlg->m_ctrlListMsgTable.GetItemCount(), lpModuleName);
      pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex, ID_SUBITEM_PATH, strDirName);
      pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex, ID_SUBITEM_ERR, ::ErrorCode2Str(dwErrCode));
   }
   if (hMod) {
      CUserDataParam pUserData(pMsgTblFindedDlg, lpModuleName, strDirName);
      BOOL bRes = ::EnumResourceNames(hMod, MAKEINTRESOURCE(RT_MESSAGETABLE), EnumResNameProc_MessageTable, (LONG)&pUserData);
      ReportJob += pUserData.m_Report;
      if (!bRes) {
         DWORD dwErrCode = ::GetLastError();

         int iIndex = pMsgTblFindedDlg->m_ctrlListMsgTable.InsertItem(pMsgTblFindedDlg->m_ctrlListMsgTable.GetItemCount(), lpModuleName);
         pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex, ID_SUBITEM_PATH, strDirName);
         pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex, ID_SUBITEM_ERR, ::ErrorCode2Str(dwErrCode));

         if ((dwErrCode != ERROR_RESOURCE_TYPE_NOT_FOUND) &&
             (dwErrCode != ERROR_RESOURCE_DATA_NOT_FOUND))
         {
            LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  MsgTblViewCodeInModule: EnumResourceNames: module [%s]: "), lpModuleName), dwErrCode);
         }
      }
      if (!::FreeLibrary(hMod)) {
         DWORD dwErrCode = ::GetLastError();
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) ::Format(_T("  MsgTblViewCodeInModule: FreeLibrary('%s'): "), lpModuleName), dwErrCode);
      }
   }
   return ReportJob;
}

/////////////////////////////////////////////////////////////////////////////

BEGIN_MESSAGE_MAP(CMsgTblFindedDlg, CDialog)
	//{{AFX_MSG_MAP(CMsgTblFindedDlg)
	ON_BN_CLICKED(IDC_BUTTON_FIND, OnButtonFind)
	ON_WM_SIZE()
	ON_WM_DRAWITEM()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CMsgTblViewDlg, CMsgTblFindedDlg)
	//{{AFX_MSG_MAP(CMsgTblViewDlg)
	ON_BN_CLICKED(IDC_BUTTON_GET_OPEN, OnButtonOpenDirFile)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_BUTTON_FIND, OnButtonFind)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CMsgTblFindedDlg::CMsgTblFindedDlg(CWnd* pParent /*=NULL*/) :
   CDialog(CMsgTblViewDlg::IDD, pParent),
   m_hDCC (NULL)
{
	//{{AFX_DATA_INIT(CMsgTblFindedDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CMsgTblViewDlg::CMsgTblViewDlg(CWnd* pParent /*=NULL*/) :
   CMsgTblFindedDlg(pParent)
{
	//{{AFX_DATA_INIT(CMsgTblViewDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
}

CMsgTblFindedDlg::~CMsgTblFindedDlg() {
   for (POSITION pos = m_list_pMsgTblFindedDlg.GetHeadPosition(); pos != NULL; m_list_pMsgTblFindedDlg.GetNext(pos)) {
      delete m_list_pMsgTblFindedDlg.GetAt(pos);
   }
}

void CMsgTblFindedDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMsgTblFindedDlg)
	DDX_Control(pDX, IDC_LIST_MESSAGE_TABLE, m_ctrlListMsgTable);
	//}}AFX_DATA_MAP
}

void CMsgTblViewDlg::DoDataExchange(CDataExchange* pDX)
{
	CMsgTblFindedDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMsgTblViewDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BOOL CMsgTblFindedDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
   m_ctrlListMsgTable.InsertColumn(ID_SUBITEM_MODULE_NAME, _T("Module Name" ), LVCFMT_LEFT , 80);
   m_ctrlListMsgTable.InsertColumn(ID_SUBITEM_PATH       , _T("Path"        ), LVCFMT_LEFT , 35);
   m_ctrlListMsgTable.InsertColumn(ID_SUBITEM_ERR        , _T("Error"       ), LVCFMT_LEFT , 34);
   m_ctrlListMsgTable.InsertColumn(ID_SUBITEM_LANG       , _T("Locale ID" ), LVCFMT_RIGHT, 80);
   m_ctrlListMsgTable.InsertColumn(ID_SUBITEM_MSG_VAL    , _T("Value"       ), LVCFMT_RIGHT, 75);
   m_ctrlListMsgTable.InsertColumn(ID_SUBITEM_MSG_HEX    , _T("Value (Hex)" ), LVCFMT_LEFT , 75);
   m_ctrlListMsgTable.InsertColumn(ID_SUBITEM_MSG_TEXT   , _T("Message text"), LVCFMT_LEFT , 1500);

   RECTEX rc(::GetWindowRect(m_hWnd));
   ::MoveWindow(m_hWnd, rc.width(rc.width()+1));
   
   SetIcon(AfxGetApp()->LoadIcon(IDI_FIND), TRUE);
   SetIcon(AfxGetApp()->LoadIcon(IDI_FIND), FALSE);

   ::SendMessage(::GetDlgItem(m_hWnd, IDC_BUTTON_FIND), BM_SETIMAGE, IMAGE_ICON, (LPARAM)AfxGetApp()->LoadIcon(IDI_FIND));

   //   
   HDC hDC = ::GetWindowDC(::GetDesktopWindow());
   m_hDCC = ::CreateCompatibleDC(hDC);
   ::ReleaseDC(::GetDesktopWindow(), hDC);

   return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CMsgTblViewDlg::OnInitDialog()
{
	CMsgTblFindedDlg::OnInitDialog();
	
	// TODO: Add extra initialization here

   SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), TRUE);
   SetIcon(AfxGetApp()->LoadIcon(IDR_MAINFRAME), FALSE);

   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_EDIT_FILE_MASK), _T("*.dll"));

   SetWindowText(PROJ_CAPTION_TEXT);

   //StartScanning(::GetSystemDirectory());
   SetTimer(ID_TIMER_FIRST_SCAN, 0, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMsgTblFindedDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
   if (m_ctrlListMsgTable.m_hWnd) {
      m_ctrlListMsgTable.MoveWindow(0, 35, cx, max(0, cy-35));
   }
   ::InvalidateRect(m_hWnd, &RECTEX(0,0,cx,35), TRUE);
}


void CMsgTblViewDlg::OnSize(UINT nType, int cx, int cy) 
{
	CMsgTblFindedDlg::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
   HWND hWndBtnOpen = ::GetDlgItem(m_hWnd, IDC_BUTTON_GET_OPEN);
   RECTEX rcBtnOpen;
   if (hWndBtnOpen) {
      rcBtnOpen = ::ScreenToClient(m_hWnd, ::GetWindowRect(hWndBtnOpen)).alignRight(cx-5);
      ::SetWindowPos(hWndBtnOpen, NULL, rcBtnOpen, SWP_NOSIZE);
   }	

   HWND hWndEditFileMask = ::GetDlgItem(m_hWnd, IDC_EDIT_FILE_MASK);
   RECTEX rcEditFileMask;
   if (hWndEditFileMask) {
      rcEditFileMask = ::ScreenToClient(m_hWnd, ::GetWindowRect(hWndEditFileMask)).alignRight(rcBtnOpen.left-5);
      ::SetWindowPos(hWndEditFileMask, NULL, rcEditFileMask, SWP_NOSIZE);
   }	

   HWND hWndStaticFileMask = ::GetDlgItem(m_hWnd, IDC_STATIC_FILE_MASK);
   RECTEX rcStaticFileMask;
   if (hWndStaticFileMask) {
      rcStaticFileMask = ::ScreenToClient(m_hWnd, ::GetWindowRect(hWndStaticFileMask)).alignRight(rcEditFileMask.left-5);
      ::SetWindowPos(hWndStaticFileMask, NULL, rcStaticFileMask, SWP_NOSIZE);
   }	

   HWND hWndCheckBoxRecursive = ::GetDlgItem(m_hWnd, IDC_CHECK_RECURSIVE);
   RECTEX rcCheckBoxRecursive;
   if (hWndCheckBoxRecursive) {
      rcCheckBoxRecursive = ::ScreenToClient(m_hWnd, ::GetWindowRect(hWndCheckBoxRecursive)).alignRight(rcStaticFileMask.left-15);
      ::SetWindowPos(hWndCheckBoxRecursive, NULL, rcCheckBoxRecursive, SWP_NOSIZE);
   }	

   HWND hWndEditReport = ::GetDlgItem(m_hWnd, IDC_EDIT_REPORT);
   RECTEX rcEditReport;
   if (hWndEditReport) {
      rcEditReport = ::ScreenToClient(m_hWnd, ::GetWindowRect(hWndEditReport));
      rcEditReport.right = rcCheckBoxRecursive.left-5;
      ::SetWindowPos(hWndEditReport, NULL, rcEditReport, SWP_NOMOVE);
   }	

}

/* static */ BOOL CALLBACK CMsgTblViewDlg::FileEnumFunc(LPCTSTR szDirName, LPCTSTR szFileName, UINT iPos, LPVOID lpParam) {
   CUserDataParam2 *pUserData = (CUserDataParam2*)lpParam;
   if (pUserData && pUserData->m_pMsgTblViewDlg) {
      pUserData->m_Report += MsgTblViewCodeInModule(pUserData->m_pMsgTblViewDlg, szDirName, szFileName);
   }
   return TRUE;
}

/* static */ BOOL CALLBACK CMsgTblViewDlg::SubDirEnumFunc(LPCTSTR szDirName, LPCTSTR szSubDirName, UINT iPos, LPVOID lpParam) {
   CUserDataParam2 *pUserData = (CUserDataParam2*)lpParam;
   if (pUserData && pUserData->m_pMsgTblViewDlg) {
      pUserData->m_Report.m_iCountDir++;
      pUserData->m_Report += pUserData->m_pMsgTblViewDlg->StartScanning(CString(szDirName)+_T('\\')+szSubDirName);
   }
   return TRUE;
}

CReportJob CMsgTblViewDlg::StartScanning(const CString &strDirName) {
   /*
   if (m_DialogWait.m_hWnd == NULL) {
      m_DialogWait.Create(IDD_DIALOG_WAIT, this);
   }
   m_DialogWait.ShowWindow(SW_SHOW);
   /**/

   HCURSOR hCur = ::SetCursor(::LoadCursor(NULL, IDC_WAIT));
   CReportJob ReportJob;
   ReportJob.m_iCountDir++;

   BOOL bRes = ::EnumFiles(strDirName, ::GetWindowText(::GetDlgItem(m_hWnd, IDC_EDIT_FILE_MASK)), CMsgTblViewDlg::FileEnumFunc, &CUserDataParam2(this, ReportJob));
   if (!bRes) {
      LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  CMsgTblViewDlg::StartScanning: EnumFiles: "), ::GetLastError());
   }

   if (BST_CHECKED == Button_GetCheck(::GetDlgItem(m_hWnd, IDC_CHECK_RECURSIVE))) {
      bRes = ::EnumSubDir(strDirName, CMsgTblViewDlg::SubDirEnumFunc, &CUserDataParam2(this, ReportJob));
      if (!bRes) {
         LOG_PUT(g_pLog, PutErrorCode, LL_ERROR) _T("  CMsgTblViewDlg::StartScanning: EnumFiles: "), ::GetLastError());
      }
   }
   hCur = ::SetCursor(hCur);
   /*
   m_DialogWait.ShowWindow(SW_HIDE);
   m_DialogWait.DestroyWindow();
   /**/

   ::SetWindowText(::GetDlgItem(m_hWnd, IDC_EDIT_REPORT), ::Format(_T("Messages - %i in %i files (Searched %i files from %i dir)"), ReportJob.m_iCountMessages, ReportJob.m_iCountFilesOk, ReportJob.m_iCountFilesAll, ReportJob.m_iCountDir));

   return ReportJob;
}

void CMsgTblFindedDlg::OnButtonFind() 
{
   if (m_DialogFind.m_hWnd == NULL) {
      m_DialogFind.Create(IDD_DIALOG_FIND, this);
   }
   m_DialogFind.ShowWindow(SW_SHOW);
   m_DialogFind.SetFocus();
}

void CMsgTblViewDlg::OnButtonOpenDirFile() 
{
   CString strDir = SelectFolder(m_hWnd);
   if (!strDir.IsEmpty()) {
      m_ctrlListMsgTable.DeleteAllItems();
      SetWindowText(PROJ_CAPTION_TEXT + (_T("   [") + strDir+_T('\\')+::GetWindowText(::GetDlgItem(m_hWnd, IDC_EDIT_FILE_MASK))+_T(']')));
      StartScanning(strDir);
   }
}

LRESULT CMsgTblFindedDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
   //LOG_PUT(g_pLog, PutWindowMessage, LL_DEBUG) _T("  CMsgTblFindedDlg::WindowProc: "), message);
   switch (message) {
   case WM_USER_FIND:
      //::BeepSpeaker();
      if (m_DialogFind.m_hWnd && !m_DialogFind.m_strFind.IsEmpty()) {
         BOOL bMatchCase = m_DialogFind.m_bMatchCase;

         CMsgTblFindedDlg *pMsgTblFindedDlg = new CMsgTblFindedDlg();
         pMsgTblFindedDlg->Create(IDD_MSGTBL_FINDED);

         HCURSOR hCur = ::SetCursor(::LoadCursor(NULL, IDC_WAIT));

         for (int i = 0; i<m_ctrlListMsgTable.GetItemCount(); i++) {


#define SEARCH_AND_COMPARE(boolVal, ID) \
            if (boolVal) { \
               CString strItemText(m_ctrlListMsgTable.GetItemText(i, ID)); \
               BOOL bFind = FALSE; \
               if (bMatchCase) { \
                  bFind = !!_tcsstr(strItemText, m_DialogFind.m_strFind); \
               } else { \
                  strItemText.MakeUpper(); \
                  CString strFind(m_DialogFind.m_strFind); \
                  strFind.MakeUpper(); \
                  bFind = !!_tcsstr(strItemText, strFind); \
               } \
               if (bFind) { \
                  int iIndex = pMsgTblFindedDlg->m_ctrlListMsgTable.InsertItem(pMsgTblFindedDlg->m_ctrlListMsgTable.GetItemCount(), m_ctrlListMsgTable.GetItemText(i, ID_SUBITEM_MODULE_NAME)); \
                  pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex, ID_SUBITEM_PATH    , m_ctrlListMsgTable.GetItemText(i, ID_SUBITEM_PATH    )); \
                  pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex, ID_SUBITEM_ERR     , m_ctrlListMsgTable.GetItemText(i, ID_SUBITEM_ERR     )); \
                  pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex, ID_SUBITEM_LANG    , m_ctrlListMsgTable.GetItemText(i, ID_SUBITEM_LANG    )); \
                  pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex, ID_SUBITEM_MSG_VAL , m_ctrlListMsgTable.GetItemText(i, ID_SUBITEM_MSG_VAL )); \
                  pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex, ID_SUBITEM_MSG_HEX , m_ctrlListMsgTable.GetItemText(i, ID_SUBITEM_MSG_HEX )); \
                  pMsgTblFindedDlg->m_ctrlListMsgTable.SetItemText(iIndex, ID_SUBITEM_MSG_TEXT, m_ctrlListMsgTable.GetItemText(i, ID_SUBITEM_MSG_TEXT)); \
               } \
            }

            SEARCH_AND_COMPARE(m_DialogFind.m_bModuleName , ID_SUBITEM_MODULE_NAME);
          //SEARCH_AND_COMPARE(m_DialogFind.m_bPath       , ID_SUBITEM_PATH       );
            SEARCH_AND_COMPARE(m_DialogFind.m_bError      , ID_SUBITEM_ERR        );
            SEARCH_AND_COMPARE(m_DialogFind.m_bLanguageID , ID_SUBITEM_LANG       );
            SEARCH_AND_COMPARE(m_DialogFind.m_bValue      , ID_SUBITEM_MSG_VAL    );
            SEARCH_AND_COMPARE(m_DialogFind.m_bValueHex   , ID_SUBITEM_MSG_HEX    );
            SEARCH_AND_COMPARE(m_DialogFind.m_bMassageText, ID_SUBITEM_MSG_TEXT   );

         }

         hCur = ::SetCursor(hCur);


         if (pMsgTblFindedDlg->m_ctrlListMsgTable.GetItemCount() > 0) {
            m_list_pMsgTblFindedDlg.AddTail(pMsgTblFindedDlg);
            pMsgTblFindedDlg->ShowWindow(SW_SHOW);
            pMsgTblFindedDlg->SetWindowText(::GetWindowText(pMsgTblFindedDlg->m_hWnd) + _T(" - [") + m_DialogFind.m_strFind + _T("]"));
         } else {
            delete pMsgTblFindedDlg;

            if (m_DialogNoFound.m_hWnd == NULL) {
               m_DialogNoFound.Create(IDD_DIALOG_NOT_FOUND, this);
            }
            ::SetWindowText(::GetDlgItem(m_DialogNoFound.m_hWnd, IDC_EDIT_NOT_FOUND), _T("Not found - ")+m_DialogFind.m_strFind);
            m_DialogNoFound.ShowWindow(SW_SHOW);
         }
      }
      break;
   }
	
	return CDialog::WindowProc(message, wParam, lParam);
}

LRESULT CMsgTblViewDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
   /*
   switch (message) {
   case WM_SYSCOMMAND:
      return CDialog::WindowProc(message, wParam, lParam);
   case WM_COMMAND:
      {
         WORD wNotifyCode = HIWORD(wParam); // notification code 
         WORD wID = LOWORD(wParam);
         if (wNotifyCode == 1)
         {
            switch (wID) {
            case IDOK:
            case IDCANCEL:
               return 0;
            }
         }
      }
      break;
   }
   /**/
	
	return CMsgTblFindedDlg::WindowProc(message, wParam, lParam);
}

BOOL CMsgTblFindedDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
   ::DeleteDC(m_hDCC);
	
	return CDialog::DestroyWindow();
}

BOOL CMsgTblViewDlg::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
   for (POSITION pos = m_list_pMsgTblFindedDlg.GetHeadPosition(); pos != NULL; m_list_pMsgTblFindedDlg.GetNext(pos)) {
      ((CWnd*)m_list_pMsgTblFindedDlg.GetAt(pos))->DestroyWindow();
   }
	
	return CMsgTblFindedDlg::DestroyWindow();
}

void CMsgTblFindedDlg::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT pDIS) 
{
   // TODO: Add your message handler code here and/or call default
   switch (nIDCtl) {
   case IDC_BUTTON_FIND:
      SIZEEX sizeWin = ::GetWindowSize(pDIS->hwndItem);

      HBITMAP hBmpNew  = ::CreateBitmap(sizeWin);
      HBITMAP hBmpOld  = (HBITMAP)::SelectObject(m_hDCC, hBmpNew);
      HFONT   hFontOld = (HFONT  )::SelectObject(m_hDCC, GetWindowFont(pDIS->hwndItem));

      BOOL bState = Button_GetState(pDIS->hwndItem);
      BOOL bIcon = GetWindowStyle(pDIS->hwndItem) & BS_ICON;
      BOOL bDown = (BST_CHECKED & bState) || (BST_PUSHED & bState);

      RECTEX rcItem = pDIS->rcItem;
      ::DrawFrameControl(m_hDCC, &rcItem, DFC_BUTTON, bDown ? DFCS_PUSHED|DFCS_BUTTONPUSH : DFCS_BUTTONPUSH);

      /**/
      int cx = ::GetSystemMetrics(SM_CXFIXEDFRAME);
      int cy = ::GetSystemMetrics(SM_CYFIXEDFRAME);
      int w = rcItem.width ()-(cx<<1);
      int h = rcItem.height()-(cy<<1);
      rcItem.move(cx,cy).width(w).height(h);
      /**/
      { // gradient fill 
         TRIVERTEX vert[2] = {
            {
               ::GetSystemMetrics(SM_CXBORDER),             // LONG    x;
               ::GetSystemMetrics(SM_CYBORDER),             // LONG    y;
               bDown ? 0x8000 : 0xF000,                     // COLOR16 Red;
               bDown ? 0x8000 : 0xF000,                     // COLOR16 Green;
               bDown ? 0x8000 : 0xF000,                     // COLOR16 Blue;
               0x0000                                       // COLOR16 Alpha;
            }, {
               -::GetSystemMetrics(SM_CXBORDER)+sizeWin.cx, // LONG    x;
               -::GetSystemMetrics(SM_CYBORDER)+sizeWin.cy, // LONG    y;   
               bDown ? 0xF000 : 0x8000,                     // COLOR16 Red;
               bDown ? 0xF000 : 0x8000,                     // COLOR16 Green;
               bDown ? 0xF000 : 0x8000,                     // COLOR16 Blue;
               0x0000                                       // COLOR16 Alpha;
            }
         };

         GRADIENT_RECT gRect = {
            0,    // ULONG UpperLeft;
            1     // ULONG LowerRight;
         };
         ::GradientFill(m_hDCC, vert, 2, &gRect, 1, GRADIENT_FILL_RECT_V);
      }/**/

      RECTEX rcIco;
      if (bIcon) {
         HICON hIcon = (HICON)::SendMessage(pDIS->hwndItem, BM_GETIMAGE, (WPARAM)IMAGE_ICON, 0L);
         rcIco = FindInnerRect((RECTEX)::SizeIcon(hIcon), rcItem);
         rcIco.alignLeft(5);

         if (bDown) {
            rcIco.move(1,1);
         }

         ::DrawIconEx(
            m_hDCC,
            rcIco.left, rcIco.top,
            hIcon,
            rcIco.width(), rcIco.height(),
            0, NULL, DI_NORMAL);
      }

      { // draw text
         RECTEX rcText = rcItem;
         if (bIcon) {
            int m = rcIco.right - rcItem.left + 5;
            rcText.moveX(m).width(rcText.width()-m);
         }
         if (bDown) {
            rcText.move(1,1);
         }

         ::SetBkMode(m_hDCC, TRANSPARENT);
         ::DrawText(m_hDCC, ::GetWindowText(pDIS->hwndItem), -1, &rcText, DT_LEFT | DT_VCENTER | DT_SINGLELINE);
      }
 
      ::BitBlt(pDIS->hDC, sizeWin, m_hDCC, SRCCOPY);

      ::SelectObject(m_hDCC, hBmpOld);
      ::SelectObject(m_hDCC, hFontOld);
   ::DeleteObject(hBmpNew);
      break;
   }

   CDialog::OnDrawItem(nIDCtl, pDIS);
}

void CMsgTblViewDlg::OnTimer(UINT nIDEvent) 
{
   // TODO: Add your message handler code here and/or call default
   switch (nIDEvent) {
   case ID_TIMER_FIRST_SCAN:
      KillTimer(ID_TIMER_FIRST_SCAN);
      OnButtonOpenDirFile();
      //SetWindowText(PROJ_CAPTION_TEXT + (_T("   [") + ::GetSystemDirectory()+_T('\\')+::GetWindowText(::GetDlgItem(m_hWnd, IDC_EDIT_FILE_MASK))+_T(']')));
      //StartScanning(::GetSystemDirectory());
      break;
   }

   CMsgTblFindedDlg::OnTimer(nIDEvent);
}
