// MsgTblViewDlg.h : header file
//

#if !defined(AFX_MSGTBLVIEWDLG_H__E2EF55C1_A513_4AF1_815F_E59553FBCD06__INCLUDED_)
#define AFX_MSGTBLVIEWDLG_H__E2EF55C1_A513_4AF1_815F_E59553FBCD06__INCLUDED_

#include "DialogFind.h"
#include "DialogNotFound.h"
#include "DialogWait.h"
#include <afxcoll.h>

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct CReportJob {
   int m_iCountMessages;
   int m_iCountFilesAll;
   int m_iCountFilesOk;
   int m_iCountDir;
   CReportJob() : 
      m_iCountMessages(0),
      m_iCountFilesAll(0),
      m_iCountFilesOk (0),
      m_iCountDir     (0) {}
   CReportJob& operator+= (const CReportJob &ReportJob) {
      m_iCountMessages += ReportJob.m_iCountMessages;
      m_iCountFilesAll += ReportJob.m_iCountFilesAll;
      m_iCountFilesOk  += ReportJob.m_iCountFilesOk;
      m_iCountDir      += ReportJob.m_iCountDir;
      return *this;
   }
};

/////////////////////////////////////////////////////////////////////////////
// CMsgTblFindedDlg dialog

class CMsgTblFindedDlg : public CDialog
{
// Construction
public:
	CMsgTblFindedDlg(CWnd* pParent = NULL);   // standard constructor
   virtual ~CMsgTblFindedDlg();

// Dialog Data
	//{{AFX_DATA(CMsgTblFindedDlg)
	enum { IDD = IDD_MSGTBL_FINDED };
	CListCtrl	m_ctrlListMsgTable;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMsgTblFindedDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
   CDialogFind     m_DialogFind;
   CDialogNotFound m_DialogNoFound;

   HDC             m_hDCC;

   CObList         m_list_pMsgTblFindedDlg;

	// Generated message map functions
	//{{AFX_MSG(CMsgTblFindedDlg)
	afx_msg void OnButtonFind();
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};
/////////////////////////////////////////////////////////////////////////////
// CMsgTblViewDlg dialog

class CMsgTblViewDlg : public CMsgTblFindedDlg
{
// Construction
public:
	CMsgTblViewDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CMsgTblViewDlg)
	enum { IDD = IDD_MSGTBLVIEW_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMsgTblViewDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
   CDialogWait m_DialogWait;

	// Generated message map functions
	//{{AFX_MSG(CMsgTblViewDlg)
	afx_msg void OnButtonOpenDirFile();
	virtual BOOL OnInitDialog();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

   CReportJob StartScanning(const CString &strDirName);

   static BOOL CALLBACK   FileEnumFunc(LPCTSTR szDirName, LPCTSTR szFileName  , UINT iPos, LPVOID lpParam);
   static BOOL CALLBACK SubDirEnumFunc(LPCTSTR szDirName, LPCTSTR szSubDirName, UINT iPos, LPVOID lpParam);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MSGTBLVIEWDLG_H__E2EF55C1_A513_4AF1_815F_E59553FBCD06__INCLUDED_)
